#! /usr/bin/env python
# -*- coding: Latin-1 -*-

# VoltaSim (Electrokit, Voltakit) - Simulation program
# (C) Grard Swinnen - Verviers, Belgium, 1986-2005
# last rev. 21/02/2005 - All rights reserved.

# Code source volontairement dstructur et d-document
# afin de contrarier le piratage. Veuillez contacter le
# distributeur du logiciel pour toute question relative
#  un dveloppement complmentaire ventuel.

import os, sys, encodings, tkMessageBox, tkFileDialog, tkSimpleDialog, time
from Tkinter import *
from random import randrange
from copy import deepcopy          
from math import log10, exp
repDes =os.path.dirname(sys.argv[0])
if not os.path.isabs(repDes):
 repDes = os.getcwd() +"/" + repDes
os.chdir(repDes)
reload(sys)   
sys.setdefaultencoding('Latin-1')
del sys.setdefaultencoding     
def inv_or_graph(rgb, factor):
 retval = "#"
 for v in [rgb[0], rgb[1], rgb[2]]:
  v = v/256 + factor     
  if v > 255: v = 255
  if v < 0:   v = 0
  retval = "%s%02x" % (retval, v)
 return retval
def deplaceCur(val):
 logv = int(log10(val))         
 ordgr = 10**logv               
 li0 = int(val/ordgr)           
 decim = val/ordgr - li0        
 li1 = int(decim*10 +.5)        
 li2 = logv -1
 return (li0, li1, li2)
def AjoutInterrupteur(s1, s2):
 if len(s1) ==0 or len(s2) ==0: return False
 for i in s1:
  if i not in s2:
   return False
 return True
class Glob:
 nomProgVer ="VoltaSim 5.12"
 docFile ='volsimhelp.txt'
 qcmFile ='volsimqcm.txt'
 fontV ='Courier 18 bold'            # valeur mesure dans multimtres
 fontR ='Helvetica 8'
 fontM ='helvetica 10'
 fontS ='Helvetica 11'
 fontG ='Helvetica 10 bold'
 fontP ='Helvetica 12 bold italic'
 fontU ='Helvetica 16 bold'          # units utilises dans multimtres
 fontN ='Helvetica 11'               # police de base
 fontB ='Helvetica 11 bold'          # mise en gras
 fontK ='Times 11 bold'
 fontT ='Times 14 bold italic'       # titres des pages
 if sys.platform =='win32':
  fontS =('MS Sans serif', 8, 'bold')
  fontM =('MS Sans serif', 10)
  fontP ='Arial 11 bold italic'
 coulFil ="#80A090"          # couleur de fil courante
 coulCanBase ="#406070"      # couleur de base du panneau de travail
 coulCan =coulCanBase       
 coulTag ="white"            # couleur des id. des lments
 riGen =0.25                
 demoOuNon =3765412
 dicoQ ={}
 passeQ =1          
 nRepQ =0           
 dureeQ =0          
 listeQ =[]         
 showIds =False         
 lumiApp =False         
 startCircuit =False    
 exampleExists =False   
class Dispositif:
 def __init__(self, boss, x, y, tag):
  self.boss = boss       
  self.x, self.y = x, y
  self.OK =True
  self.typ ="dis"
  self.E =None
  self.U =None
  self.I =None
  self.R =100.0
  self.bNeg =[]  
  self.bPos =[]  
  self.DispoSelected(tag)
  self.dessiner(x, y, tag)
 def DispoSelected(self, tag):
  self.dBorn ={} 
  for b in ('n', 'p'):
   xb, yb =self.coordBorne(b)
   self.dBorn[b] =self.boss.create_oval(xb-3, yb-3, xb+3, yb+3,
      outline ='', fill =Glob.coulFil, tags =(tag, b))
 def transform(self, tag):
  xa, ya =self.coordBorne('n')
  xb, yb =self.coordBorne('p')
  self.boss.create_rectangle(xa, ya-2, xb, yb+2,
           fill ='orange', tags =tag)
  self.boss.create_line(xa+1, ya-1, xb-1, yb-1, fill='white',
          tags =tag)        
 def annulerSel(self, U =None, I =None, R =None):
  if U !=None : self.U =U 
  if I !=None : self.I =I 
  if R !=None : self.R =R
 def dessiner(self, x, y, tag):
  self.transform(tag)   
  l2, h2 = 65, 55
  self.boss.create_rectangle(x-l2, y-h2, x+l2, y+h2, width =1,
          fill ='ivory', tags =tag)
  self.boss.create_text(x, y-45, text =tag, tags =tag)
  self.t1 =self.boss.create_text(x, y+30, text ="U : None", tags =tag)
  self.t2 =self.boss.create_text(x, y+45, text ="I : None", tags =tag)
  self.t3 =self.boss.create_text(x, y+15, text ="R : 100", tags =tag)
  self.t4 =self.boss.create_text(x, y -15, text ="N", tags =tag)
  self.t5 =self.boss.create_text(x, y -30, text ="P", tags =tag)
 def refresh(self):
  self.boss.itemconfigure(self.t1, text ="U : %s" % self.U) 
  self.boss.itemconfigure(self.t2, text ="I : %s" % self.I) 
  self.boss.itemconfigure(self.t3, text ="R : %s" % self.R) 
  t ="N:"
  for v in self.bNeg:
   t = t +" " +v 
  self.boss.itemconfigure(self.t4, text = t ) 
  t ="P:"
  for v in self.bPos:
   t = t +" " +v 
  self.boss.itemconfigure(self.t5, text = t )
 def coordBorne(self, b):
  dx ={'n':-70, 'p':+70}[b] 
  return self.x +dx, self.y
 def dilateBorne(self, b):
  xb, yb =self.coordBorne(b)
  self.boss.coords(self.dBorn[b], xb-6, yb-6, xb+6, yb +6) 
 def recupQCM(self, b):
  if len({'n':self.bNeg, 'p':self.bPos}[b]) >0: return
  xb, yb =self.coordBorne(b)
  self.boss.coords(self.dBorn[b], xb-3, yb-3, xb+3, yb +3)
 def refaddToolCompl(self):
  pass
 def inverser(self):
  pass
class supprDispo(Dispositif):
 def __init__(self, boss, x, y, tag ='t', sens =1, volt =1.53, appli=None):
  self.sens =sens
  self.volt ="%4.2g V" % volt
  Dispositif.__init__(self, boss, x, y, tag)
  self.typ ="pil"
  self.R =Glob.riGen
  self.E =volt*sens
  self.tag =tag
  self.appli =appli      
 def coordBorne(self, id):
  dy ={'n':70, 'p':-70}[id] 
  return self.x, self.y +dy -3*self.sens
 def dessiner(self, x, y, tag):
  l2, h2, s = 30, 65, self.sens
  self.boss.create_rectangle(x-l2+3, y-h2+4, x+l2+3, y+h2+4, width =0,
       stipple ="gray75", fill ="grey30", tags =tag)
  couCorps ="#8050A0"   #"dark violet"#"purple" #"cadet blue"
  rgb = self.boss.winfo_rgb(couCorps)     
  couBand = inv_or_graph(rgb, -50)           
  self.boss.create_polygon(x-l2+13, y-h2*s,
         x-l2+17, y-(h2+6)*s,
         x+l2-17, y-(h2+6)*s,
         x+l2-13, y-h2*s, outline ="black",
         fill ='grey80', tags =tag)
  self.boss.create_line(x-l2+19, y-(h2+5)*s, x+l2-19, y-(h2+5)*s,
         fill ="white", tags=tag)
  self.boss.create_rectangle(x-l2, y-h2, x+l2, y+h2,
          fill =couCorps, width =1, tags =tag)
  self.boss.create_text(x, y+15*s, text='Volta+', width =0,
         font =Glob.fontP, fill ="Yellow", tags =tag)
  self.boss.create_text(x, y-30*self.sens, text=self.volt,
         font =Glob.fontG, fill ="ivory", tags =tag)
  self.boss.create_rectangle(x-l2+1, y-h2*.8*s, x+l2-1, y-h2*.6*s,
          fill =couBand, width =0, tags =tag)
  self.boss.create_text(x, y-h2*.8*s, text='+',
         font =Glob.fontV, fill ="ivory", tags =tag)
  self.boss.create_rectangle(x-l2*.8, y-h2+5, x-l2*.5, y+h2-3,
          fill ='white', width =0, tags =tag,
          stipple ="gray50")
  self.boss.create_rectangle(x+l2*.7, y-h2+5, x+l2*.8, y+h2-3,
          fill ='white', width =0, tags =tag,
          stipple ="gray50")
  self.boss.create_line(x-l2+2, y-h2+3, x+l2-2, y-h2+3, fill ="white",
          stipple ="gray50", width =2, tags=tag)
  self.boss.create_line(x-l2+2, y+h2-1, x+l2-2, y+h2-1,
         stipple ="gray50",
         fill ="white", width =1, tags=tag)
  if Glob.showIds:
   self.boss.create_text(x, y+h2*.6*s, text=tag, tags=tag, fill='white')
 def inverser(self):
  self.boss.delete(self.tag)
  self.sens = -self.sens
  self.E = -self.E
  self.dBorn ={} 
  for b in ('n', 'p'):
   xb, yb =self.coordBorne(b)
   self.dBorn[b] =self.boss.create_oval(xb-3, yb-3, xb+3, yb+3,
          outline ='',
          fill =Glob.coulFil, tags =(self.tag, b))
  self.dessiner(self.x, self.y, self.tag)
  for b in ('p', 'n'): self.dilateBorne(b)
  self.appli.refresh()
 def refresh(self):
  pass               
 def transform(self, tag):
  pass               
class effacerToutCompl(Dispositif):
 cc = ['black','#A05000','#E00000','orange','yellow',
    '#00E000','#0000E0','purple','grey50','white']
 def __init__(self, boss, x, y, tag ='t', size =1, val =100., ori ='h'):
  self.size =size
  self.ori =ori
  Dispositif.__init__(self, boss, x, y, tag)
  self.R =val
  self.Rnom =int(val)    
  self.P =(2, 1, 0.5, 0.25)[size]
  self.typ ="res"
  self.Balloon()
 def coordBorne(self, id):
  dim =(70, 63, 56, 49)[self.size]
  dz ={'n':-dim, 'p':dim}[id] 
  if self.ori =='h': return self.x +dz, self.y
  else: return self.x, self.y +dz
 def transform(self, tag):
  xa, ya =self.coordBorne('n')
  xb, yb =self.coordBorne('p')
  if self.ori =="h":
   self.boss.create_rectangle(xa, ya-2, xb, yb+2,
           fill ='orange', tags =tag)
   self.boss.create_line(xa+1, ya-1, xb-1, yb-1,
           fill='white', tags =tag)        
  else:
   self.boss.create_rectangle(xa-2, ya, xb+2, yb,
           fill ='orange', tags =tag)
   self.boss.create_line(xa-1, ya+1, xb-1, yb-1,
           fill='white', tags =tag)        
 def dessiner(self, x, y, tag):
  ori = (self.ori =='v')
  dl, dh = ((45,15),(40,14),(35,13),(30,12))[self.size]
  l2, h2 =((dl,dh), (dh,dl))[ori]
  self.boss.create_rectangle(x-l2+3, y-h2+4, x+l2+3, y+h2+4, width =0,
       stipple ="gray75", fill ="grey30", tags =tag)
  self.transform(tag)
  self.boss.create_rectangle(x-l2, y-h2, x+l2, y+h2,
          fill ='grey40', width =1, tags =tag)
  x1,y1,x2,y2 =((x-l2+1, y-h2*.8, x+l2-1, y-h2*.5),
       (x-l2*.8, y-h2+1, x-l2*.5, y+h2-1))[ori]
  self.boss.create_rectangle(x1, y1, x2, y2,
          fill ='grey80', width =0, tags =tag)
  self.ligne =[]       
  z, dz =((x,l2),(y,h2))[ori] 
  for zz in (z-dz*.7, z-dz*.3, z+dz*.1):
   x1,y1,x2,y2 =((zz, y-h2+1, zz+l2/4, y+h2),
        (x-l2+1, zz, x+l2, zz+h2/4))[ori]
   self.ligne.append(self.boss.create_rectangle(x1, y1, x2, y2,
         fill='black', width=0, tags =tag))
   x1,y1,x2,y2 =((zz, y-h2*.8, zz+l2/4, y-h2*.5),
        (x-l2*.8, zz, x-l2*.5, zz+h2/4))[ori]
   self.ligne.append(self.boss.create_rectangle(x1, y1, x2, y2,
       fill='grey', width=0, tags =tag))
  x1,y1,x2,y2 =((x-l2+1, y+h2*.7, x+l2-1, y+h2*.8),
       (x+l2*.7, y-h2+1, x+l2*.8, y+h2-1))[ori]
  self.boss.create_rectangle(x1, y1, x2, y2, stipple ="gray50",
          fill ='grey70', width =0, tags =tag)
  if Glob.showIds:
   x1, y1 =((x, y-25),(x-25, y))[ori]
   self.boss.create_text(x1, y1, text=tag, tags=tag,
          fill=Glob.coulTag)
 def Balloon(self):
  li = deplaceCur(float(self.R))        
  m =0
  for n in range(3):
   cou =self.cc[li[n]]
   self.boss.itemconfigure(self.ligne[m], fill =cou)
   m += 1
   rgb = self.boss.winfo_rgb(cou)      
   cou = inv_or_graph(rgb, 100)           
   self.boss.itemconfigure(self.ligne[m], fill =cou)
   m += 1
 def refresh(self):
  if self.OK and self.U and self.I:
   if self.U * self.I > self.P:
    self.OK =False
    self.R = 1e9
class tracerFils(Dispositif):
 def __init__(self, boss, x, y, tag ='t', UNom =2.9):
  self.UNom =UNom    
  Dispositif.__init__(self, boss, x, y, tag)
  self.balise =tag
  self.R =25.0       
  self.typ ="bul"
 def dessiner(self, x, y, tag):
  e =3
  cBase, cSock, cBulb ='#504010', 'grey70', 'black'
  cReflS ='ivory'    # reflets sur le socket
  cContour ='#301000'     # brun trs sombre
  for r, c in ((45,cBase),(30,cSock),(24,cBulb)):
   self.boss.create_arc(x-r-2, y-r-2, x+r, y+r, tags =tag,
      start=60, extent =180, outline =cReflS, width =2)
   self.stat =self.boss.create_oval(x-r, y-r, x+r, y+r,
      tags =tag, fill =c, outline =cContour, width =e)
   e -= 1
  a = randrange(180)
  self.fil1 =self.boss.create_arc(x-13, y-13, x+13, y+13, tags =tag,
     start = a, extent =10, width =5, outline ='black')                               
  self.fil2 =self.boss.create_arc(x-13, y-13, x+13, y+13, tags =tag,
     start = a+180, extent =10, width =5, outline ='black')                               
  r =16
  self.boss.create_arc(x-r, y-r, x+r, y+r, tags =tag, start =100,
        extent =60, outline ='grey80', width =5,
        stipple ="gray50", style =ARC)    
  self.boss.create_arc(x-r, y-r, x+r, y+r, tags =tag, start =295,
        extent =30, outline ='grey80', width =2,
        stipple ="gray50", style =ARC)
  for x1, x2 in ((-70, -37),(35, 70)):            
   self.boss.create_rectangle(x+x1, y-2, x+x2, y+2,
          fill ='orange', tags =tag)
   self.boss.create_line(x+x1+1, y-1, x+x2-1, y-1,
          fill='white', tags =tag)
  self.boss.create_text(x-5, y+5, text="%2.0f V" % self.UNom,
          tags=tag, fill="grey")
  if Glob.showIds:
   self.boss.create_text(x-42, y-42, text=tag, tags=tag,
          fill=Glob.coulTag)
 def refaddToolCompl(self):
  if self.OK:
   Rd =8 + abs(self.I) *500
   self.R =(self.R +Rd)/2
 def refresh(self):
  if self.U ==None: return
  uAppl =abs(self.U)
  if uAppl > self.UNom *1.13:
   if self.OK:
    s = (5,-8, 3,5, 12,-17, 10,7, 12,-9)
    f = [self.x -19, self.y +15]
    i = 0
    for d in s:
     f.append(f[i] +d)
     i +=1
    self.boss.create_line(f, fill ='grey', width =1,
           tags =self.balise)
    self.OK = False                
    self.R =1e8
    self.boss.event_generate('<Control-Z>')
  if self.OK:
   cou='#400800'           # coul. de base (rouge sombre)
   f = uAppl*356/self.UNom - 50
   rgb = self.boss.winfo_rgb(cou)  
   cou1 = inv_or_graph(rgb, f)        
   f = uAppl*256/self.UNom - 50
   rgb = self.boss.winfo_rgb(cou)  
   cou2 = inv_or_graph(rgb, f)        
  else:
   cou1 = cou2 ='black'
  self.boss.itemconfig(self.stat, fill = cou2)
  self.boss.itemconfig(self.fil1, outline = cou1)
  self.boss.itemconfig(self.fil2, outline = cou1)
class Diode(Dispositif):
 def __init__(self, boss, x, y, tag ='t', iMax =0.072, sens =1, appli =None):
  self.sens =sens        
  Dispositif.__init__(self, boss, x, y, tag)
  self.iMax =iMax        
  self.R =2500.
  self.Rmin =.65
  self.Rmax =500000.
  self.typ ="dio"
  self.tag =tag
  self.appli =appli
 def coordBorne(self, id):
  dx ={'n':-40, 'p':+40}[id] 
  return self.x +dx, self.y
 def transform(self, tag):
  xa, ya =self.coordBorne('n')
  xb, yb =self.coordBorne('p')
  self.boss.create_oval(xa+30, ya-5, xb-30, yb+5, fill ='black',
         outline ='grey80', width =1, tags =tag)
  for xx, s in ((xa, 1), (xb, -1)):
   self.boss.create_rectangle(xx, ya-2, xx+36*s, yb+2,
           fill ='orange', tags =tag)
   self.boss.create_line(xx+s, ya-1, xx+35*s, yb-1,
          fill='white', tags =tag)
 def dessiner(self, x, y, tag):
  l2, h2 = 20, 10
  self.boss.create_rectangle(x-l2+3, y-h2+4, x+l2+3, y+h2+4, width =0,
       stipple ="gray75", fill ="grey30", tags =tag)
  self.transform(tag)
  self.boss.create_rectangle(x-l2, y-h2, x+l2, y+h2, stipple ="gray25",
          fill ='grey60', width =1, tags =tag)
  y1, y2 =y-h2, y+h2
  x1, x2 ={-1:(x-l2+7, x-l2+14), 1:(x+l2-7, x+l2-14)}[self.sens]
  self.boss.create_rectangle(x1, y1, x2, y2,
         fill='black', width=0, tags =tag)
  x1,y1,x2,y2 =x-l2+1, y-h2*.8, x+l2-1, y-h2*.5
  self.boss.create_rectangle(x1, y1, x2, y2, stipple ="gray50",
           fill ='grey90', width =0, tags =tag)
  x1,y1,x2,y2 =x-l2+1, y+h2*.7, x+l2-1, y+h2*.8
  self.boss.create_rectangle(x1, y1, x2, y2, stipple ="gray50",
          fill ='grey80', width =0, tags =tag)    
  if Glob.showIds:
   self.boss.create_text(x, y-23, text=tag, tags=tag,
          fill=Glob.coulTag)
 def inverser(self):
  self.sens =-self.sens
  self.boss.delete(self.tag)
  self.DispoSelected(self.tag)    
  self.dessiner(self.x, self.y, self.tag)
  for b in ('p', 'n'): self.dilateBorne(b)
  self.appli.refresh()
 def refaddToolCompl(self):
  if not self.OK: return        
  if self.I: sgn = int(self.I/abs(self.I))   
  else: sgn =0
  if sgn == self.sens:
   Ud =abs(self.U)
   if self.typ =='dio':
    Rd = 3 + 6e9*exp(-Ud*30)
   elif self.typ =='led':
    Rd = 3 + 6e18*exp(-Ud*30)
   if Rd > self.R:
    self.Rmin = self.R
   else:
    self.Rmax =self.R
   self.R =(self.Rmin + self.Rmax) /2
  else:
   self.R =1e6
 def refresh(self):
  if self.I ==None: return
  if abs(self.I) > self.iMax:
   self.OK =False
   self.R =1e7    
   self.boss.event_generate('<Control-Z>')
  if self.OK:
   self.Rmin, self.Rmax =2., 500000.
class buttonCoords(Diode):
 def __init__(self, boss, x, y, tag ='t', iMax =0.035, sens =1, appli =None):
  self.cou ='#A00000'     # ncessaire pour dessiner
  Diode.__init__(self, boss, x, y, tag, iMax, sens, appli)
  self.typ ="led"
  self.Rmin =1.35
 def dessiner(self, x, y, tag):
  self.boss.create_rectangle(x-8, y-45, x+14, y-3,
           stipple ="gray75",
           fill ="grey30", width =0, tags =tag)
  self.d =[]
  self.d.append(self.boss.create_oval(x-10, y-55, x+10, y-35,
      fill =self.cou, tags =tag))
  x1, x2 = {-1:(x-12, x+17),1:(x-17, x+12)}[self.sens]
  self.d.append(self.boss.create_rectangle(x1, y-15, x2, y-10,
      fill =self.cou, tags =tag))
  self.d.append(self.boss.create_rectangle(x-10, y-45, x+10,
        y-15, fill =self.cou, width =0, tags =tag))
  for xx in (-10, 10):
   self.boss.create_line(x+xx, y-45, x+xx, y-15, tags =tag)
  self.boss.create_arc(x-7, y-52, x+7, y-38, tags =tag, start =80,
      extent =100, outline ='white', width =2, style =ARC)    
  self.boss.create_line(x-7, y-45, x-7, y-17, fill='white',
         width =2, tags =tag)
  self.boss.create_line(x+9, y-45, x+9, y-17, fill='grey',
         width =1, tags =tag)
  self.boss.create_line(x1+2, y-15, x1+2, y-10, fill='white',
         width =2, tags =tag)
  self.boss.create_line(x2-1, y-15, x2-1, y-10, fill='grey',
         width =1, tags =tag)                              
  for s in (-1, 1):
   f =(x+4*s,y-10, x+8*s,y-10, x+8*s,y-2,
    x+40*s,y-2, x+40*s,y+2, x+4*s,y+2)
   self.boss.create_polygon(f, fill ='orange', tags =tag,
      outline ='black', width =1)
   self.boss.create_line(x+8*s, y-1, x+39*s, y-1,
          fill='white', tags =tag)
  self.boss.create_line(x+5, y-9, x+5, y+1,
          fill='white', tags =tag)
  self.boss.create_line(x-7, y-9, x-7, y-1,
          fill='white', tags =tag)
  if Glob.showIds:
   self.boss.create_text(x-30, y-40, text=tag, tags=tag,
          fill=Glob.coulTag)
 def refresh(self):
  if self.I ==None: return
  Diode.refresh(self)
  if self.OK:
   if self.I: sgn = int(self.I/abs(self.I))   
   else: sgn =0
   if sgn == self.sens and abs(self.I) >.0005:
    cou ="#A00000"                  # couleur de base
    rgb = self.boss.winfo_rgb(cou)  
    f = abs(self.I)*50/.03 +40
    cou = inv_or_graph(rgb, f)        
   else: cou =self.cou
   self.Rmin, self.Rmax =2., 500000.
  else:
   cou =self.cou
  for d in self.d:
   self.boss.itemconfigure(d, fill=cou)
class Toolbar:
 def __init__(self, boss):
  self.boss =boss        
  self.fen =None         
  self.status =0         
 def Curseur(self, evt, pos, text):
  if self.status in (1, 2): return    
  geo = self.boss.geometry().split('+')
  xW, yW = int(geo[1]), int(geo[2])          
  self.x, self.y = xW +pos[0], yW +pos[1]    
  self.text =unicode(text)        
  if self.status ==0:
   self.status =1                         
   self.boss.after(1000, self.deconnecter)
  elif self.status ==3:                      
   self.status =1
   self.deconnecter()                           
 def deconnecter(self):
  if self.status ==1:     
   self.fen = Toplevel(self.boss)
   self.fen.overrideredirect(1)       
   self.fen.geometry("+%s+%s" % (self.x, self.y))
   self.fen.transient(master =self.boss)          
   Label(self.fen, text =self.text, bg='ivory',
      font =Glob.fontM).pack()
   self.status =2                         
   self.boss.after(2000, self.quit)
  else:
   self.status =0     
 def quit(self, evt=None):
  if self.fen:
   self.fen.destroy()
   self.fen =None
  self.status =0
 def bind(self, widget, pos, text):
  widget.bind("<Enter>",
   lambda event, a1=pos, a2=text: self.Curseur(event, a1, a2))
  widget.bind("<Leave>", self.mouseOut)
 def mouseOut(self, evt):
  if self.fen:
   self.fen.destroy()
   self.fen =None
  self.status =3     
  self.boss.after(2000, self.quit)
class cursorReleased(Frame):
 def __init__(self, boss):
  Frame.__init__(self)
  self.appli = boss
  self.cli, self.flag = False, False   
  self.tip =Toolbar(self.appli.master)
  self.icon =[]          
  self.dTool ={"res":(7,'resist4',"Ajouter une rsistance"),
      "bul":(5,'bulb1c',"Ajouter une ampoule"),
      "gen":(3,'power1a',"Ajouter un gnrateur  tension rglable"),
      "led":(6,'diode4',"Ajouter une diode"),
      "pil":(2,'power1f',"Ajouter une pile"),
      "hlp":(11,'contents',"Consulter le guide de travail / l'aide en ligne"),
      "inf":(12,'readme'," propos de %s ..." % Glob.nomProgVer),
      "bak":(1,'filesave',"Prfrences, sauvegarde"),
      "vol":(9,'volt2',"Ajouter un voltmtre"),
      "amp":(10,'ampere2',"Ajouter un ampremtre"),
      "var":(8,'var_res2',"Ajouter une rsistance variable"),
      "swi":(4,'switch1d',"Ajouter un interrupteur")}
  self.fr1 =Frame(self)
  for id, tool in self.dTool.items():
   self.PileOrdinaire(id, tool)
  self.info =Label(self, bg='#004040', width =40, bd =3, relief =SUNKEN)
  self.fr1.pack(side =LEFT)
  self.info.pack(side =RIGHT, padx =5)
 def PileOrdinaire(self, id, tool):
  imFile =tool[1] +'.gif'
  self.icon.append(PhotoImage(file = imFile))
  bou = Button(self.fr1, image =self.icon[-1],
      width =32, height =32, bd =2, relief =GROOVE,
      command = lambda arg =id: self.action(arg))
  bou.grid(row =0, column =tool[0])  
  self.tip.bind(bou, (tool[0]*40, 70), tool[2])
 def action(self, item):
  self.appli.ajouter(item, self.dTool[item])
 def message(self, msg, fg ="black", cligno =False):
  self.info.config(text =msg, fg=fg)
  if cligno:
   if not self.cli:
    self.cli =True
    self.timer()
  else: self.cli =False
 def timer(self):
  if self.cli:
   self.flag = not self.flag
   fg =("red", "#700000")[self.flag]
   self.info.config(fg=fg)        
   self.after(300, self.timer)
class Bouton:
 bg, fg, refl, ombr, enfo = "grey30", "white", "grey80", "grey10", '#402040'
 def __init__(self, can, x, y, tag =None, txt =None, dev=None, id =0):
  self.boss =can
  self.dev =dev          
  self.txt =txt
  self.tag =tag
  self.id =id
  self.GuideTravail(x, y)
 def GuideTravail(self, x, y):
  tag =self.tag
  haut, larg = 25, 74
  self.base =self.boss.create_rectangle(x, y, x+larg, y+haut,
       fill =self.bg, outline =self.ombr,
       tags =(tag, "bouton", str(self.id)))
  refl =(x+larg,y, x,y, x,y+haut)
  self.r1 =self.boss.create_line(refl, fill =self.refl, tags =tag)
  self.boss.create_text(x+larg/2, y+haut/2+1,
       text =str(self.txt), fill =self.fg,
       font =Glob.fontG, tags =(tag, "bout", str(self.id)))
 def setValue(self):
  self.boss.itemconfigure(self.base, fill =self.enfo, outline =self.refl)
  self.boss.itemconfigure(self.r1, fill =self.ombr)
 def mouseIn(self):
  self.boss.itemconfigure(self.base, fill =self.bg, outline =self.ombr)
  self.boss.itemconfigure(self.r1, fill =self.refl)
  self.dev.selButton(self.id)           
class BoutonsRadio:
 bg, fg, refl, ombr, enfo = "grey30", "white", "grey80", "grey10", '#402040'
 def __init__(self, can, x, y, tag =None, var=None, txts =None, dev=None, ori ="H"):
  self.boss =can
  self.var =var          
  self.dev =dev          
  self.txts =txts
  self.tag =tag
  self.ori =ori
  self.GuideTravail(x, y)
 def GuideTravail(self, x, y):
  tag =self.tag
  haut, larg = 25, 40
  self.dessins =[]
  for n, txt in enumerate(self.txts):
   if n == self.var: cb =self.enfo ; re =self.ombr ; om =self.refl
   else: cb =self.bg ; re =self.refl ; om =self.ombr 
   self.dessins.append(self.boss.create_rectangle(x,y,x+larg,y+haut,
       fill =cb, width =1, tags =(tag, "bouR", str(n))))
   refl =(x+1,y+haut-1, x+1,y+1, x+larg-1,y+1)
   self.dessins.append(self.boss.create_line(refl,
                  fill =re, tags =tag))
   ombr =(x+larg-1,y+1, x+larg-1,y+haut-1, x+1, y+haut-1)
   self.dessins.append(self.boss.create_line(ombr,
                fill =om, tags =tag))
   self.dessins.append(self.boss.create_text(x+larg/2, y+haut/2+1,
       text =str(txt), fill =self.fg, font =Glob.fontG,
       tags =(tag, "bouR", str(n))))
   if self.ori =="H": x += larg
   else : y += haut
 def setValue(self, choosed):
  self.var = choosed                 
  for d in self.dessins: self.boss.delete(d)
  x, y = self.dev.TraceGraphiqueIU()
  self.GuideTravail(x, y)
  self.dev.selButton(self.var)           
class Switch:
 bg, fg, refl, ombr, enfo = "grey30", "white", "grey80", "grey10", '#402040'
 def __init__(self, can, x, y, tag =None, plots =10, dev=None, ori ="H",
      size = 150, val =None, max =100.):
  self.boss =can
  self.dev =dev          
  self.plots =plots      
  self.ori =ori
  self.max =max          
  self.size =size
  self.dessine(x, y, val, tag)
 def dessine(self, x, y, val, tag):
  l2 =self.size/2
  xg = val*self.size/self.max
  self.boss.create_rectangle(x-l2, y-3, x+l2, y+3,
           fill =self.enfo, tags =tag)
  refl =(x-l2+1,y+2, x+l2-1,y+2, x+l2-1,y-2)
  self.boss.create_line(refl, fill =self.refl, tags =tag)
  pas = (self.size -4.)/self.plots       
  for u in range(self.plots +1):
   xx, yy = x-l2+2+pas*u, y-13
   if u % 5 == 0:
    yy =y-17
    v = int(self.max*u/self.plots)
    self.boss.create_text(xx, y-24, text =str(v),
         font =Glob.fontG, fill =self.fg, tags =tag)
   self.boss.create_line(xx, y-8, xx, yy, fill =self.fg,
          width =2, tags =tag)
  self.g1 =self.boss.create_rectangle(x-l2+xg-4, y-15, x-l2+xg+4, y+15,
         fill =self.bg, tags =(tag, "cur"))
  refl =(x-l2+xg-3,y+14, x-l2+xg-3,y-14, x-l2+xg+3,y-14)
  self.g2 =self.boss.create_line(refl, fill =self.refl,
            tags =(tag, "cur"))
 def SpinWidget(self, dx):
  x =self.dev.x
  xmin =x -self.size/2 -1
  xmax =xmin +self.size -5               
  xc = self.boss.coords(self.g2)[0]      
  if xc +dx < xmin:
   dx = xmin -xc
  if xc +dx > xmax:
   dx = xmax -xc
  self.boss.move(self.g1, dx, 0)
  self.boss.move(self.g2, dx, 0)
 def mouseIn(self):
  x =self.dev.x
  xmin =x -self.size/2 -1
  xc = self.boss.coords(self.g2)[0]
  val =(xc-xmin)*self.max/(self.size -5)     
  self.dev.coloreLignes(val)
class AmpouleOrdinaire:
 def __init__(self, boss, eWidth=6, aWidth =20, vList=[0], liInd=0,
     justify =CENTER, orient =VERTICAL):
  self.boss =boss            
  self.vList =vList          
  self.liInd =liInd          
  self.cadre =Frame(boss)    
  if orient ==VERTICAL:
   side =TOP
   self.arrowUp =PhotoImage(file = "arrowup.gif")
   self.arrowDn =PhotoImage(file = "arrowdown.gif")
  else:
   side =RIGHT
   self.arrowUp =PhotoImage(file = "arrowright.gif")
   self.arrowDn =PhotoImage(file = "arrowleft.gif")
  Button(self.cadre, image=self.arrowUp, width =aWidth,
      command=self.up).pack(side= side)
  self.champ = Label(self.cadre, bg ='white', width=eWidth,
         anchor =justify,
         text =str(vList[liInd]), relief =SUNKEN)
  self.champ.pack(pady =3, side= side)
  Button(self.cadre, image=self.arrowDn, width =aWidth,
      command=self.down).pack(side= side)
 def up(self):
  if self.liInd < len(self.vList) -1:
   self.liInd += 1
  else:
   self.cadre.bell()      
  self.champ.configure(text =str(self.vList[self.liInd]))
 def down(self):
  pass
  if self.liInd > 0:
   self.liInd -= 1
  else:
   self.cadre.bell()
  self.champ.configure(text =str(self.vList[self.liInd]))
 def get(self):
  return self.vList[self.liInd]
class ajusteRi(Toplevel):
 def __init__(self, appli):
  Toplevel.__init__(self) 
  self.title(unicode(" * Premire utilisation : informations de licence *"))
  self.resizable(width =0, height =0)    
  self.transient(master =appli)          
  self.protocol('WM_DELETE_WINDOW', self.proceder)
  self.appli =appli
  appli.licensedTo =unicode("Version de dmonstration")
  appli.licenseNum =0
  Label(self, text =unicode("Veuillez complter les champs ci-dessous pour\n"+\
     "dverrouiller compltement le logiciel.\n\nAttention : les chanes de caractres que vous "+\
     "entrez ici doivent\ncorrespondre exactement (maj. et "+\
     "minuscules seront distingues)\n celles qui ont t "+\
     "enregistres par votre distributeur agr."),
     font =Glob.fontM).pack(padx =15, pady =4)
  Label(self, text =unicode("Nom du titulaire de la licence :"),
     font =Glob.fontG).pack(pady =4)
  self.e1 =Entry(self, width =30)
  self.e1.pack()
  Label(self, text =unicode("Numro de licence :"),
     font =Glob.fontG).pack()
  self.e2 =Entry(self)
  self.e2.pack()
  Label(self, text =unicode("Si vous cliquez sur 'Ignorer', ou si "+\
     "vous entrez un numro\nde licence erron, le logiciel "+\
     "fonctionnera en mode 'dmo.'"),
     font =Glob.fontM).pack(padx =15, pady =4)
  Button(self, text ="Ignorer", width =10, command =self.quitter).\
      pack(side =LEFT, padx =15, pady =4)
  Button(self, text ="OK", width =10, command =self.proceder).\
      pack(side =RIGHT, padx =15, pady =4)
  scrX, scrY = self.winfo_screenwidth(), self.winfo_screenheight()
  self.geometry("+%d+%d" % (scrX/2 -220, scrY/2-180))
 def proceder(self):
  err =False
  numF = self.e2.get()
  try:
   prefix = int(numF[0:3])
   num = int(numF[4:10])*1000 +int(numF[11:14])
  except:
   err =True
  if len(numF) != 14: err =True
  if err:
   tkMessageBox.showinfo(" Erreur",
   unicode("Numro de licence incorrect. Veuillez recommencer."))
   return
  u8str = self.e1.get()      
  self.appli.licensedTo = u8str.encode("Latin-1") 
  self.appli.licenseNum = num
  try:
   ofi =open("pelo" + "use.j" + "pg","r+b")
   ofi.seek(6789)
   ofi.write("%03d%09d\n" % (prefix, num + 254482556))
   ofi.write(self.appli.licensedTo +"\n")
   ofi.close()
  except:    
   tkMessageBox.showinfo(" Erreur",
   unicode("Impossible d'effectuer l'initialisation.\n"\
     "Veuillez rinstaller le logiciel."))
  self.destroy()
  self.appli.styleChange()
 def quitter(self):
  self.appli.sousEnsemble()
  self.destroy()
class addTool(Dispositif):
 bg, fg, dbg, dfg, sbg = "grey30", "white", "#B09040", "black", '#402040'
 def __init__(self, boss, x, y, tag ='t'):
  Dispositif.__init__(self, boss, x, y, tag)
  self.typ ='swi'
  self.R =1e8
 def coordBorne(self, id):
  dx ={'n':-72, 'p':72}[id] 
  return self.x +dx, self.y +35
 def dessiner(self, x, y, tag):
  h, l2 = 70, 55
  self.boss.create_rectangle(x-l2+5, y+6, x+l2+5, y+h+6,
           stipple ="gray75",
           fill =self.bg, width =0, tags =tag)
  xa, ya =self.coordBorne('n')
  xb, yb =self.coordBorne('p')
  self.boss.create_rectangle(xa, ya-2, xb, yb+2,
           fill ='orange', tags =tag)
  self.boss.create_line(xa+1, ya-1, xb-1, yb-1, fill='white',
          tags =tag)        
  self.boss.create_rectangle(x-l2, y, x+l2, y+h,
           fill =self.bg, width =1, tags =tag)
  refl =(x-l2,y+h, x-l2,y, x+l2,y)
  self.boss.create_line(refl, width =0, fill ="grey", tags =tag)
  self.voyant =self.boss.create_oval(x-4, y+10, x+4, y+18,
        fill="#000000", width =3, tags =tag)
  txts =("O","I")
  xz, yz =self.TraceGraphiqueIU()
  self.br = BoutonsRadio(self.boss, xz, yz, tag, dev =self,
         var =0, txts =txts, ori ="H")
  if Glob.showIds:
   self.boss.create_text(x, y+h+12, text =tag, tags =tag,
          fill =Glob.coulTag)
 def TraceGraphiqueIU(self):
  return self.x-40, self.y +30
 def selButton(self, choosed):
  self.R =(1e8, 1e-5)[choosed]
  coul =("#000000","#00A000")[choosed]
  self.boss.itemconfigure(self.voyant, fill=coul)
  self.boss.event_generate('<Control-Z>')
 def refresh(self):
  return           
class addTool2D(Dispositif):
 bg, fg, dbg, dfg, sbg = "grey30", "white", "#B09040", "black", '#402040'
 def __init__(self, boss, x, y, tag ='t', sens =1, appli =None):
  self.sens =sens
  self.appli =appli
  Dispositif.__init__(self, boss, x, y, tag)
  self.typ ='sw2'
  self.R =1e8
  self.tag =tag
 def DispoSelected(self, tag):
  self.dBorn ={}         
  for b in ('n', 'p', 'q'):
   xb, yb =self.coordBorne(b)
   self.dBorn[b] =self.boss.create_oval(xb-3, yb-3, xb+3, yb+3,
      outline ='', fill =Glob.coulFil, tags =(tag, b))
 def coordBorne(self, id):
  dx ={-1:-63, 1:63}[self.sens]
  dx ={'n':-dx, 'p':dx, 'q':dx}[id]
  dy ={'n':0, 'p':20, 'q':-20}[id]
  return self.x +dx, self.y +35 +dy
 def dessiner(self, x, y, tag):
  h, l2 = 70, 47
  self.boss.create_rectangle(x-l2+5, y+6, x+l2+5, y+h+6,
           stipple ="gray75",
           fill =self.bg, width =0, tags =tag)
  xa, ya =self.coordBorne('n')
  xb, yb =self.coordBorne('p')
  xc, yc =self.coordBorne('q')
  lf = {1:40, -1:-40}[self.sens]
  s =self.sens
  for xx, yy, zz, s in((xa, ya, lf, s), (xb, yb, -lf, -s),
        (xc, yc, -lf, -s)):
   self.boss.create_rectangle(xx, yy-2, xx+zz, yy+2,
           fill ='orange', tags =tag)
   self.boss.create_line(xx+s, yy-1, xx+(zz-1), yy-1,
           fill='white', tags =tag)        
  self.boss.create_rectangle(x-l2, y, x+l2, y+h,
           fill =self.bg, width =1, tags =tag)
  refl =(x-l2,y+h, x-l2,y, x+l2,y)
  self.boss.create_line(refl, width =0, fill ="grey", tags =tag)
  self.voyant =[]
  for n, xx, yy in ((0, xb-lf, yb-5), (1, xc-lf, yc+5)):
   cou =("#000000","#00A000")[n]       
   self.voyant.append(self.boss.create_oval(xx-4, yy-4, xx+4, yy+4,
        fill=cou, width =3, tags =tag))
  txts =("I","II")
  xz, yz =self.TraceGraphiqueIU()
  self.br =BoutonsRadio(self.boss, xz, yz, tag, dev =self,
         var =0, txts =txts, ori ="V")
  if Glob.showIds:
   self.boss.create_text(x, y+h+12, text =tag, tags =tag,
          fill =Glob.coulTag)
 def TraceGraphiqueIU(self):
  return self.x-20-13*self.sens, self.y +10
 def selButton(self, choosed):
  self.R =(1e8, 1e-5)[choosed]
  self.swc.R =(1e-5, 1e8)[choosed]
  cou =(("#000000","#00A000"),("#00A000","#000000"))[choosed]
  for n in (0,1):
   self.boss.itemconfigure(self.voyant[n], fill=cou[n])
  self.boss.event_generate('<Control-Z>')
 def showIt(self, swc, swcId):
  self.swc =swc
  self.swcId =swcId
 def refresh(self):
  pass           
class addToolCompl(Dispositif):
 def __init__(self, boss, sw1):
  Dispositif.__init__(self, boss, 100, 100, 't')
  self.R =1e-5
  self.typ ='swc'
  self.sw1 =sw1      
 def dessiner(self, x, y, tag):
  pass               
 def DispoSelected(self, tag):
  self.dBorn ={}     
 def coordBorne(self, id):
  if id =='p': id ='q'
  return self.sw1.coordBorne(id)
 def refresh(self):
  pass               
class VareffacerToutCompl(Dispositif):
 bg, fg, dbg, dfg, sbg = "grey30", "white", "#B09040", "black", '#402040'
 def __init__(self, boss, x, y, tag ='t', vMax =1e4):
  self.vMax =vMax
  self.curVal =3.
  Dispositif.__init__(self, boss, x, y, tag)
  self.typ ='var'        
  self.R =self.curVal*self.fc
 def dessiner(self, x, y, tag):
  h, l2 = 120, 100
  self.boss.create_rectangle(x-l2+5, y+6, x+l2+5, y+h+6,
           stipple ="gray75",
           fill =self.bg, width =0, tags =tag)
  xa, ya =self.coordBorne('n')
  xb, yb =self.coordBorne('p')
  for xx in (xa, xb):
   self.boss.create_rectangle(xx-2, ya-40, xx+2, ya,
           fill ='orange', tags =tag)
   self.boss.create_line(xx-1, ya-40, xx-1, ya-1,
          fill='white', tags =tag)
  self.boss.create_rectangle(x-l2, y, x+l2, y+h,
           fill =self.bg, width =1, tags =tag)
  refl =(x-l2,y+h, x-l2,y, x+l2,y)
  self.boss.create_line(refl, width =0, fill ="grey", tags =tag)
  self.fc = int(self.vMax/10)
  for t, dy in (("Rsistance variable", 16),
       ("x %s ohms" % self.fc, 86)):
   self.boss.create_text(x, y+dy, fill=self.fg, anchor =CENTER,
      text =t, font =Glob.fontG, tags =tag)
  self.boss.create_text(x, y+h-15, text ='Pmax = 1.5 W',
     font=Glob.fontR, fill =self.fg, anchor =CENTER, tags =tag)
  self.curseur =Switch(self.boss, x, y+60, tag, plots =10, dev=self,
      size =150, val =self.curVal, max =10.)
  if Glob.showIds:
   self.boss.create_text(x, y+h+12, text =tag, tags =tag,
          fill =Glob.coulTag)
 def coordBorne(self, id):
  dx ={'n':80, 'p':-80}[id] 
  return self.x +dx, self.y +135
 def coloreLignes(self, val):
  self.curVal =float(val)
  if self.OK:
   self.R =self.curVal*self.fc
   if self.R == 0.0: self.R =0.1  
  self.boss.event_generate('<Control-Z>')
 def refresh(self):
  if self.OK and self.U and self.I:
   if self.U * self.I > 1.5:
    self.OK =False
    self.R =1e8
class DiodeLuminescente(Dispositif):
 bg, fg, dbg, dfg, sbg = "grey30", "white", "#B09040", "black", '#402040'
 def __init__(self, boss, x, y, tag ='t'):
  self.curseur ='0.0'
  self.marche =False
  self.sens =1
  self.curVal =5.37
  Dispositif.__init__(self, boss, x, y, tag)
  self.R =1e7    
  self.E =0.0
  self.typ ='gen'
 def dessiner(self, x, y, tag):
  h, l2 = 155, 130
  self.boss.create_rectangle(x-l2+5, y+6, x+l2+5, y+h+6,
           stipple ="gray75",
           fill =self.bg, width =0, tags =tag)
  xa, ya =self.coordBorne('n')
  xb, yb =self.coordBorne('p')
  for xx in (xa, xb):
   self.boss.create_rectangle(xx-2, ya-40, xx+2, ya,
           fill ='orange', tags =tag)
   self.boss.create_line(xx-1, ya-40, xx-1, ya-1, fill='white',
          tags =tag)
  self.boss.create_rectangle(x-l2, y, x+l2, y+h,
           fill =self.bg, width =1, tags =tag)
  refl =(x-l2,y+h, x-l2,y, x+l2,y)
  self.boss.create_line(refl, width =0, fill ="grey", tags =tag)
  dx, dy, cou = 0, 19, self.fg
  self.boss.create_text(x+dx, y+dy, fill=cou, anchor =CENTER,
         text ="Alimentation continue 0-15V",
         font =Glob.fontG, tags =tag)
  self.curseur =Switch(self.boss, x, y+75, tag, plots =15, dev=self,
      size =200, val =self.curVal, max =15.)
  self.boutons =[]       
  self.boutons.append(Bouton(self.boss, x-76, y +h-40, tag, dev =self,
           txt ="Polarit", id =0))
  self.boutons.append(Bouton(self.boss, x+2, y +h-40, tag, dev =self,
           txt ="Ma./Ar.", id =1))
  self.tg =self.boss.create_oval(xa-7, ya-31, xa+7, ya-51,
         width =1, fill ='grey10', tags =tag)
  self.td =self.boss.create_oval(xb-7, yb-31, xb+7, yb-51,
         width =1, fill ='grey10', tags =tag)
  self.pg =self.boss.create_text(xa+1, ya-40, text =" ", fill='grey',
            font =Glob.fontV, tags =tag)
  self.pd =self.boss.create_text(xb+1, yb-40, text =" ", fill='grey',
            font =Glob.fontV, tags =tag)
  for xr, yr in ((xa,ya),(xb,yb)):
   self.boss.create_arc(xr-6, yr-31, xr+6, yr-50, start =70,
        extent =150, outline ='ivory', width =1,
        stipple ="gray50", style =ARC, tags =tag)
  if Glob.showIds:
   self.boss.create_text(x, y+h+15, text =tag, tags =tag,
          fill =Glob.coulTag)
 def selButton(self, id):
  if id ==0:
   self.AjoutResistance()
  elif id ==1:
   self.timing()
 def coordBorne(self, id):
  dx ={'n':105, 'p':-105}[id] 
  return self.x +dx, self.y +170
 def AjoutResistance(self):
  self.sens = {-1:1, 1:-1}[self.sens]
  self.setVoltage()
 def timing(self):
  self.marche = (True, False)[self.marche]
  if self.marche: self.R =Glob.riGen
  else: self.R =1e7
  self.setVoltage()
 def setVoltage(self):
  if self.marche:
   cpos, cneg = ('#FF8040', '#40FFA0')
   c1, s1 ={1:(cpos,'+'), -1:(cneg,'-')}[self.sens]
   c2, s2 ={1:(cneg,'-'), -1:(cpos,'+')}[self.sens]
   c3 ='grey40'
  else:
   c1 = c2 = 'grey10'
   c3 = 'grey'
   s1 = s2 = " "
  self.boss.itemconfigure(self.td, fill =c1)
  self.boss.itemconfigure(self.tg, fill =c2)
  self.boss.itemconfigure(self.pd, text =s1, fill =c3)
  self.boss.itemconfigure(self.pg, text =s2, fill =c3)
  self.setFEM()
 def coloreLignes(self, val):
  self.curVal =float(val)
  self.setFEM()
 def setFEM(self):
  if self.marche:
   self.E =self.curVal*self.sens
  else:
   self.E =0.0
  self.boss.event_generate('<Control-Z>')
 def effacerTout2D(self, E):
  self.E = E*self.sens
  self.curseur.SpinWidget(30) 
 def refresh(self):
  pass               
class suppriConnex(Dispositif):
 bg, fg, sbg = "grey30", "white", '#402040'
 def __init__(self, boss, x, y, tag ='t', dev =0, sens =1):
  self.dfg =("black","green")[Glob.lumiApp]
  self.dbg =("#B09040","dark green")[Glob.lumiApp]
  self.dev =dev          
  self.sens =sens
  self.calibre =2
  Dispositif.__init__(self, boss, x, y, tag)
  self.R =(2E6, 1)[dev]
  self.typ =('vol','amp')[dev]
 def dessiner(self, x, y, tag):
  h, l2 = 140, 100
  self.boss.create_rectangle(x-l2+5, y+6, x+l2+5, y+h+6,
      stipple ="gray75", fill =self.bg, width =0, tags =tag)
  xa, ya =self.coordBorne('n')
  xb, yb =self.coordBorne('p')
  for xx in (xa, xb):
   self.boss.create_rectangle(xx-2, ya-40, xx+2, ya,
           fill ='orange', tags =tag)
   self.boss.create_line(xx-1, ya-40, xx-1, ya-1,
        fill='white', tags =tag)
  caption = ('Voltmtre','Ampremtre')[self.dev] +' digital'
  self.boss.create_rectangle(x-l2, y, x+l2, y+h, fill =self.bg,
           width =1, tags =tag)
  refl =(x-l2,y+h, x-l2,y, x+l2,y)
  self.boss.create_line(refl, width =0, fill ="grey", tags =tag)
  dx, dy, cou = 0, 16, self.fg
  self.boss.create_text(x+dx, y+dy, fill=cou, anchor =CENTER,
    text =caption, font =Glob.fontG, tags =tag)
  self.labGauche =self.boss.create_text(xb, yb-25, fill=self.fg,
    anchor =CENTER, text ="-", font =Glob.fontU, tags =tag)
  self.labDroite =self.boss.create_text(xa, ya-25, fill=self.fg,
    anchor =CENTER, text ="+", font =Glob.fontU, tags =tag)
  rgb = self.boss.winfo_rgb(self.dbg)  
  dbgE = inv_or_graph(rgb, 70)            
  dbgA = inv_or_graph(rgb, -70)           
  self.boss.create_rectangle(x-l2+19, y+35, x+l2-19, y+95,
       fill =self.dbg, outline =dbgE, width =2, tags =tag)
  self.boss.create_line(x-l2+19, y+35, x-l2+19, y+95,
       fill =dbgA, width =2, tags =tag)
  self.boss.create_line(x-l2+19, y+35, x+l2-19, y+35,
       fill =dbgA, width =2, tags =tag)
  self.resAff =self.boss.create_text(x, y +80, text ='R interne',
      font =Glob.fontR, fill =self.dfg, tags =tag)
  self.uniAff =self.boss.create_text(x+l2-45, y+57, text ='mU',
      font=Glob.fontU, fill =self.dfg, tags =tag)
  self.valAff =self.boss.create_text(x+l2-65, y+57, text ='8.88',
     anchor =E, font=Glob.fontV, fill =self.dfg, tags =tag)
  txts =((1,10,100),(10,100,1000))[self.dev]
  xz, yz =self.TraceGraphiqueIU()
  self.br = BoutonsRadio(self.boss, xz, yz, tag, dev =self,
         var =self.calibre, txts =txts, ori ="H")
  if Glob.showIds:
   self.boss.create_text(x, y+h+12, text =tag, tags =tag,
         fill =Glob.coulTag)
  self.refresh()
 def coordBorne(self, id):
  dx ={'n':80, 'p':-80}[id] 
  return self.x +dx, self.y +155
 def refresh(self):
  val =(self.U, self.I)[self.dev]
  if val ==None: val =0.0    
  c =self.calibre
  vMax =((3,30,300),(.007,.07,.7))[self.dev][c]
  format =(('%7.1f', '%7.3f', '%7.2f'),
     ('%7.3f', '%7.2f', '%7.1f'))[self.dev][c]
  unit =(('mV','V','V'),('mA','mA','mA'))[self.dev][c]
  res =(('30 K','300 K','3 M'),
     ('0.5','0.05','0.005 '))[self.dev][c]
  self.R =((3e4, 3e5, 3e6),
     (0.5, 0.05, 0.005))[self.dev][c]
  self.boss.itemconfigure(self.resAff, text ="Ri : %sOhms" % res)
  if abs(val) > vMax:
   self.boss.itemconfigure(self.valAff, text =' * Err ')
   self.boss.itemconfigure(self.uniAff, text ='--')
  else:
   m = ((1000,1,1),(1000,1000,1000))[self.dev][c]
   val *= m*self.sens            
   self.boss.itemconfigure(self.valAff, text =format % val)
   self.boss.itemconfigure(self.uniAff, text =unit)
 def TraceGraphiqueIU(self):
  return self.x-60, self.y +105
 def selButton(self, choosed):
  self.calibre =choosed
  self.refresh()
  self.boss.event_generate('<Control-Z>')
 def inverser(self):
  self.sens =-self.sens
  lG, lD ={-1:("+","-"), 1:("-","+")}[self.sens]
  self.boss.itemconfigure(self.labGauche, text=lG)
  self.boss.itemconfigure(self.labDroite, text=lD)
  self.refresh()
 def transform(self, tag):
  pass               
class Panneau(Frame):
 def __init__(self, boss):
  Frame.__init__(self)
  self.appli =boss
  self.selObject =None
  self.dispSel =None
  self.bind("<Configure>", self.redim)
  self.can =Canvas(self, width =800, height =600,
       scrollregion =(0, 0, 1600, 1200), bg =Glob.coulCan)
  self.can.grid(row =0, column =0)
  self.bdv = Scrollbar(self, orient =VERTICAL, command =self.can.yview)
  self.bdh = Scrollbar(self, orient =HORIZONTAL, command =self.can.xview)
  self.can.config(xscrollcommand =self.bdh.set,      
      yscrollcommand= self.bdv.set)
  self.bdv.grid(row =0, column =1, sticky = NS)      
  self.bdh.grid(row =1, column =0, sticky = EW)      
  self.can.bind("<Button-1>", self.mouseDown)
  self.can.bind("<Button1-Motion>", self.mouseMove)
  self.can.bind("<Button1-ButtonRelease>", self.mouseUp)
  self.can.bind("<Button-3>", self.mouseRight)
  self.can.bind("<Button3-ButtonRelease>", self.mouseUp)
  if sys.platform =="darwin":
   self.can.bind("<Double-Button-1>", self.mouseRight)
 def redim(self, event):
  larg, haut = event.width -20, event.height -20
  self.can.config(width =larg, height =haut)
 def mouseDown(self, event):
  if self.appli.secWinPresent: return 
  x = self.x1 = self.x0 = self.can.canvasx(event.x)
  y = self.y1 = self.y0 = self.can.canvasy(event.y)
  self.bout =None
  self.curs =None
  c1 =self.can.find_enclosed(x-10, y-10, x+10, y+10)
  if len(c1) ==1:                
   c2 =self.can.gettags(c1)   
   if len(c2) >1 and c2[1] != 'current':
    self.act ='bind'        # crer un fil-guide temporaire :
    self.can.create_line(x,y,x,y, fill="grey", tags='guide')
    self.noeud =(c2[0], c2[1]) 
   else:
    self.act ='move'
  else:
   c1 =self.can.find_closest(self.x1, self.y1)
   if len(c1) ==0: return     
   self.act ='move'
   c2 =self.can.gettags(c1)   
  self.selObject = c2[0]         
  if "bouR" in c2:            # cas d'un bouton radio :
   for i, ta in enumerate(c2):
    if ta =="bouR": but = int(c2[i+1]) ; break
   br =self.appli.dicoD[c2[0]].br
   br.setValue(but)
  elif "bout" in c2:          # cas d'un bouton simple
   for i, ta in enumerate(c2):
    if ta =="bout": but = int(c2[i+1]) ; break
   self.bout =self.appli.dicoD[c2[0]].boutons[but]
   self.bout.setValue()
  elif "cur" in c2:           # cas d'un curseur
   self.act ='curMove'
   self.curs =self.appli.dicoD[c2[0]].curseur
  elif "fond" in c2:          # cas d'une ligne de cahier
   self.selObject =None
   return
  if self.selObject[0] =='@': self.selObject =None ; return
  if self.act =='move': self.can.lift(self.selObject)
 def mouseUp(self, event):
  if self.selObject:
   x = self.can.canvasx(event.x)
   y = self.can.canvasy(event.y)
   if self.act =='bind':
    c1 =self.can.find_enclosed(x-10, y-10, x+10, y+10)
    if len(c1) >0:
     c2 =self.can.gettags(c1)
     self.appli.lier(self.noeud, c2)            
   self.can.delete('guide')      # effacer fil guide temporaire
   self.selObject =None         
   if self.bout:
    self.bout.mouseIn()
    self.bout =None
   if self.curs:
    self.curs.mouseIn()
    self.curs =None
 def mouseMove(self, event):
  if self.selObject:
   x2, y2 = self.can.canvasx(event.x), self.can.canvasy(event.y)
   if self.act =='move':
    dx, dy = x2 -self.x1, y2 -self.y1
    self.can.move(self.selObject, dx, dy)    
    self.x1, self.y1 = x2, y2
    if self.selObject =="current": return
    self.appli.choix1(self.selObject, dx, dy)
    self.appli.print_dTemp(self.selObject, dx, dy)
   elif self.act =='curMove':
    dx = x2 -self.x1
    self.x1 =x2
    self.curs.SpinWidget(dx)            
   else:
    c = self.can.coords('guide')
    x1, y1 = c[0], c[1]
    self.can.coords('guide', x1, y1, x2, y2)
 def mouseRight(self, event):
  if self.selObject: return      
  if self.dispSel: return        
  x = self.can.canvasx(event.x)
  y = self.can.canvasy(event.y)
  d = self.can.find_closest(x, y)
  t = self.can.gettags(d)
  if "fond" in t: return      # lment de fond (ligne de cahier)
  if len(t) < 1: return
  if t[0][0] =="@":           # il s'agit bien d'un fil
   id = int(t[0][1:])
   self.appli.TestQCM(id)
   self.appli.refresh()
  else:
   id = t[0][0]
   self.dispSel = VarsuppriConnex(self.appli, self, id)
 def Generator(self):
  self.dispSel =None
class VarsuppriConnex(Toplevel):
 def __init__(self, appli, panneau, idd):
  Toplevel.__init__(self) 
  self.title(unicode(" Slection de l'lment %s" % idd))
  self.resizable(width =0, height =0)    
  self.geometry("+200+150")               # ("400x200+200+150")
  self.transient(master =appli)          
  self.protocol('WM_DELETE_WINDOW', self.sortie)
  self.appli =appli
  self.panneau =panneau
  self.msg1 =Label(self, font =Glob.fontS, wraplength ='9.5c')
  self.msg1.pack()
  self.msg2 =Label(self, font =Glob.fontS, wraplength ='9.5c')
  self.msg2.pack()
  Label(self, width =1).pack(side =LEFT)     
  Button(self, text =unicode("Enlever l'lment"), font =Glob.fontS,
      width =21, command = lambda arg =idd: self.enlever(arg))\
      .pack(side =LEFT, padx =1, pady =5)            
  self.bou2 = Button(self, font =Glob.fontS,
      width =21, command = lambda arg =idd: self.EntrerInfosLicence(arg))
  self.bou2.pack(side =LEFT, pady =5)
  Button(self, text ="Terminer", font =Glob.fontS,
      command =self.sortie).pack(side =LEFT, padx =1, pady =5)
  Label(self, width =1).pack(side =LEFT)     
  self.codeCoul(idd)
 def codeCoul(self, idd):
  disp =self.appli.dicoD[idd]
  self.dTyp =disp.typ        
  if self.dTyp =="res":
   t ="une rsistance de %s Ohms, %s Watt" % (disp.Rnom, disp.P)
  elif self.dTyp =="dio":
   t ="une diode ordinaire (au silicium).\n" +\
      "Intensit maximale admissible " +\
      "= %d milliAmpres" % (disp.iMax * 1000) 
  elif self.dTyp =="led":
   t ="une diode luminescente.\nIntensit maximale admissible " +\
      "= %d milliAmpres" % (disp.iMax * 1000) 
  elif self.dTyp =="pil":
   t ="une pile de %2.1f Volts" % disp.E
  elif self.dTyp =="bul":
   t ="une ampoule de 3 Volts, 0,2 W"     # % disp.UNom
  elif self.dTyp =="gen":
   t ="un gnrateur  courant continu"
  elif self.dTyp =="amp":
   t ="un milliampremtre lectronique digital"
  elif self.dTyp =="vol":
   t ="un voltmtre lectronique digital"
  elif self.dTyp =="var":
   t ="une rsistance variable (0-%s ohms, 1,5 W)" % int(disp.vMax)            
  elif self.dTyp =="swi":
   t ="un interrupteur simple"
  elif self.dTyp =="sw2":
   t ="un interrupteur inverseur"
  else:
   t =self.dTyp
  self.msg1.configure(text =\
    unicode("L'lment slectionn (%s) est \n%s." % (idd, t))) 
  if disp.OK:
   if disp.U and disp.I and\
      self.dTyp in('res','var','bul','dio','led'):
    p = disp.U * disp.I
    t ="Il dissipe actuellement une puissance de %4.3f Watts." % p
   else:
    t ="- en ordre de marche -"
   c ="black"
  else:
   t ="Ayant t surcharg, ce dispositif est dsormais hors d'usage."
   c ="#DD0000"
  self.msg2.configure(text =unicode(t), fg =c) 
  if self.dTyp =="gen": t = "Trac de graphiques I/U"
  else: t ="Inverser les polarits"
  if self.dTyp in ('var','res','swi','sw2','bul'): st =DISABLED
  else: st =NORMAL
  self.bou2.configure(text =unicode(t), state =st)
 def enlever(self, idd):
  self.appli.supprimer(idd)
  self.sortie()
 def EntrerInfosLicence(self, idd):
  if self.dTyp =='gen': ChoixGraphiqueIU(self.appli, idd)
  else : self.appli.inverser(idd)
  self.sortie()
 def sortie(self):
  self.panneau.Generator()
  self.appli.sousEnsemble()
  self.destroy()
class ChoixGraphiqueIU(Toplevel):
 def __init__(self, appli, idd):
  Toplevel.__init__(self)
  self.title(unicode(" Trac de graphiques I = f(U)"))
  self.resizable(width =0, height =0)    
  self.geometry("+200+150")           # ("400x200+200+150")
  self.transient(master =appli)     
  self.appli = appli
  self.idG =idd
  Label(self, text=unicode("Ce dispositif trace automatiquement pour vous "+\
   "divers graphiques de l'intensit en fonction de la tension.\n" +\
   "Lorsque vous cliquerez sur le bouton 'Tracer le graphique', "+\
   "le gnrateur actuellement slectionn produira une variation "+\
   "progressive de tension, de 0  15 V. "+\
   "Au cours de cette variation, les indications "+\
   "d'un voltmtre et d'un ampremtre de votre choix seront "+\
   "mmorises et traduites en un graphique.\n\n"+\
   "Le voltmtre et l'ampremtre doivent avoir t installs "+\
   "au pralable aux emplacements adquats dans le circuit.\n"+\
   "Si vous utilisez plusieurs de ces appareils, il peut tre "+\
   "utile d'activer l'option :'Afficher les id. des lments', "+\
   "dans le menu des prfrences."), 
   font =Glob.fontM, wraplength ='11.0c').pack(padx =12)
  fr1 =Frame(self)
  Label(fr1, text =unicode("Id. du voltmtre choisi :"),
     font =Glob.fontS)\
    .grid(row =1, column =1, padx =5, pady =2, sticky =E)
  p =['-']
  for idd, disp in self.appli.dicoD.items():
   if disp.typ =="vol": p.append(idd)
  self.vol =AmpouleOrdinaire(fr1, eWidth=3, orient =HORIZONTAL,
         aWidth =12, vList =p, liInd=0)
  self.vol.cadre.grid(row =1, column =2)
  Label(fr1, text =unicode("Id. de l'ampremtre choisi :"),
     font =Glob.fontS)\
     .grid(row =2, column =1, padx =5, pady =2, sticky =E)
  p =['-']
  for idd, disp in self.appli.dicoD.items():
   if disp.typ =="amp": p.append(idd)
  self.amp =AmpouleOrdinaire(fr1, eWidth=3, orient =HORIZONTAL,
         aWidth =12, vList =p, liInd=0)
  self.amp.cadre.grid(row =2, column =2)
  Label(fr1, text =unicode("Nombre de points de mesure :"),
     font =Glob.fontS)\
     .grid(row =3, column =1, padx =5, pady =2, sticky =E)
  p =[5, 10, 15, 20, 25, 30]
  self.mes =AmpouleOrdinaire(fr1, eWidth=3, orient =HORIZONTAL,
         aWidth =12, vList =p, liInd=0)
  self.mes.cadre.grid(row =3, column =2)
  fr1.pack()
  Button(self, text ="Annuler", font =Glob.fontS,
      command =self.destroy).pack(side =RIGHT, padx =5, pady =5)
  Button(self, text ="Tracer le graphique", font =Glob.fontS,
      command = self.SoyantStuut)\
      .pack(side =RIGHT, pady =5)
 def nouvCoords(self, text, fact, incr):
  return self.counterPMW(text, fact, incr, "vol")
 def creerBornes(self, text, fact, incr):
  return self.counterPMW(text, fact, incr, "amp")
 def counterPMW(self, text, fact, incr, typeD):
  p =['-']
  for idd, disp in self.appli.dicoD.items():
   if disp.typ ==typeD: p.append(idd)
  i =p.index(text)
  i += fact
  if i >= len(p): i =len(p)-1 ; self.bell()
  if i <0: i =0; self.bell()
  return p[i]
 def SoyantStuut(self):
  if not self.appli.dicoD[self.idG].marche:
   tkMessageBox.showwarning(" Attention",
    unicode("Vous devez d'abord mettre le gnrateur en marche."))
   return
  idV, idA = self.vol.get(), self.amp.get()
  if idV =='-' or idA =='-':
   tkMessageBox.showwarning(" Attention",
    unicode("Vous devez slectionner d'abord deux appareils de mesure."))
   return
  nMes =int(self.mes.get())
  Resistor(self.appli, self.idG, idV, idA, nMes)
  self.destroy() 
class Resistor(Toplevel):
 def __init__(self, appli, idG, idV, idA, mes):
  Toplevel.__init__(self)
  self.title(unicode(" Trac de graphiques I = f(U)"))
  self.resizable(width =0, height =0)    
  self.geometry("+200+150")               # ("400x200+200+150")
  self.transient(master =appli)          
  self.appli = appli
  self.idA, self.idV = idA, idV
  self.gen =appli.dicoD[idG]
  self.amp =appli.dicoD[idA]
  self.vol =appli.dicoD[idV]
  self.can =Canvas(self, width =500, height =480, bg ='ivory')
  self.can.pack()
  self.dessiner(mes)
 def dessiner(self, mes):
  dE = 15.0 / (mes -1)
  Ilist, Ulist =[], []
  Umax, Imax = 0., 0.
  Ip, In, Up, Un = False, False, False, False
  for n in range(mes):
   self.gen.effacerTout2D(n*dE)
   self.appli.refresh()
   I, U = self.amp.I, self.vol.U
   Ilist.append(I)
   Ulist.append(U)
   if U >0 : Up =True     
   if I >0 : Ip =True     
   if U <0 : Un =True     
   if I <0 : In =True     
   I, U = abs(I), abs(U)
   if U > Umax: Umax =U   
   if I > Imax: Imax =I   
  if Umax ==0 or Imax ==0: return
  echU =(400., 200.)[Up and Un]    
  echI =(400., 200.)[Ip and In]    
  Umm =Umax ; w = int(log10(Umm))
  if w <0: w-=1
  b =10**w ; c = int(Umm/b) +1 ; Umm = float(b*c)
  Imm =Imax ; w = int(log10(Imm))
  if w <0: w-=1
  b =10**w ; c = int(Imm/b) +1 ; Imm = float(b*c)
  if Imm < 1e-3: Imm = 1e-3      
  if Umm < 1: Umm =1.0           
  fU, fI = echU/Umm, echI/Imm    
  zx =(50, 250)[Up and Un]       
  zy =(440, 240)[Ip and In]      
  y1, y2 = 40, 440
  for n in range(11):
   x1 =x2 = 50 + n*40
   cou =("black","blue")[x1 ==zx]
   w =(1,2)[x1 ==zx]
   self.can.create_line(x1, y1, x2, y2, fill=cou, width =w)            
  x1, x2 = 50, 450
  for n in range(11):
   y1 = y2 = 440 - n*40
   cou =("black","blue")[y1 ==zy]
   w =(1,2)[y1 ==zy]
   self.can.create_line(x1, y1, x2, y2, fill =cou, width =w)
  tta =((45,20,"I (mA)"), (454,425,"U (V)"),
     (320,20,"Voltmtre %s & Ampremtre %s" % (self.idV, self.idA)))
  ttb=(((27,440,"0"),(50,455,"0"),
     (27,40,"%4.1f" % (Imm*1000)), (27,240,"%4.1f" % (Imm*500)),
     (450,455,"%4.1f" % Umm), (250,455,"%4.1f" % (Umm/2))),
    ((27,240,"0"),(250,455,"0"),
     (27,40,str(int(Imm*1000))), (27,440,str(-int(Imm*1000))),
     (50,455,"%4.1f" % (-Umm)), (450,455,"%4.1f" % Umm)))[Up and Un]
  for x,y,t in tta: 
   self.can.create_text(x,y, text =unicode(t), font =Glob.fontS)
  for x,y,t in ttb: 
   self.can.create_text(x,y, text =unicode(t), font =Glob.fontS)
  curve =[]
  for n in range(mes):
   U, I = Ulist[n], Ilist[n]
   if not (Up and Un): U =abs(U)
   if not (Ip and In): I =abs(I)  
   x = zx + U * fU
   y = zy - I * fI
   curve.append((x, y))
  self.can.create_line(curve, fill="red", smooth =0, width =2)
  for x, y in curve:
   self.can.create_oval(x-4, y-4, x+4, y+4, fill='cyan')
class showInfos(Toplevel):
 def __init__(self, appli, x, y, tag):
  Toplevel.__init__(self)    
  self.title(unicode(" Ajout d'un interrupteur"))
  self.resizable(width =0, height =0)    
  self.geometry("+200+150")
  self.transient(master =appli)     
  self.protocol('WM_DELETE_WINDOW', self.sortie)
  self.appli =appli
  self.x, self.y = x, y
  self.tag =tag
  self.typ =IntVar()
  self.ima1 =PhotoImage(file = 'symb_sw1.gif')
  self.ima2 =PhotoImage(file = 'symb_sw2.gif')
  self.ima3 =PhotoImage(file = 'symb_sw3.gif')
  Label(self, text =unicode("Choisissez le type d'interrupteur :"),
      font =Glob.fontP).pack(pady =5)
  fr1 =Frame(self)
  Radiobutton(fr1, text =unicode("Interrupteur simple :"),
       font =Glob.fontS,
       variable =self.typ, value =1, command =self.choixRep)\
      .pack(side =LEFT)
  Label(fr1, image =self.ima1, font =Glob.fontS)\
      .pack(side =LEFT, padx =10)
  fr1.pack(padx =10, pady =5, anchor=W)
  Radiobutton(self,
     text =unicode("Interrupteur inverseur (va-et-vient) :"),
     variable =self.typ, value =2, width =35, anchor =W,
     command =self.choixRep, font =Glob.fontS).pack(padx =10)
  fr2 =Frame(self)
  self.sens =IntVar()
  self.r3 = Radiobutton(fr2, text ="droite :", state ='disabled',
        variable =self.sens, value =1, font =Glob.fontS)
  self.r3.pack(side =LEFT)
  self.i3 = Label(fr2, image =self.ima2, state ='disabled')
  self.i3.pack(side =LEFT, padx =5)
  self.r4 = Radiobutton(fr2, text ="gauche :", state ='disabled',
        variable =self.sens, value =-1, font =Glob.fontS)
  self.r4.pack(side =LEFT)
  self.i4 = Label(fr2, image =self.ima3, state ='disabled')
  self.i4.pack(side =LEFT, padx =5)
  fr2.pack()
  Button(self, text ='OK', command =self.sortie, width =5).\
      pack(padx =10, pady =5, side =RIGHT)
  self.typ.set(1)
  self.sens.set(1)
 def choixRep(self):
  c = self.typ.get()
  if c == 2: st ='normal'
  else: st ='disabled'
  for item in (self.i3, self.i4, self.r3, self.r4):
   item.config(state =st)
 def sortie(self):
  appli =self.appli
  tag =self.tag
  if self.typ.get() == 1:
   appli.dicoD[tag] = addTool(appli.can, self.x, self.y, tag)
  else:
   sens =self.sens.get()
   appli.dicoD[tag] = addTool2D(appli.can, self.x, self.y,
          tag, appli =appli, sens =sens)
   sw1 =appli.dicoD[tag]
   tag2 =appli.Application()      
   appli.dicoD[tag2] =addToolCompl(appli.can, sw1)
   sw2 =appli.dicoD[tag2]
   sw1.showIt(sw2, tag2)
   sw1.bNeg.append(tag2 +'n')
   sw2.bNeg.append(tag +'n')
   appli.can.itemconfigure(sw1.dBorn['q'], tags =(tag2, 'p', tag))
   sw2.dBorn['p'] =sw1.dBorn['q']
  self.appli.sousEnsemble()
  self.destroy()
class goTo(Toplevel):
 def __init__(self, appli, x, y, tag):
  Toplevel.__init__(self)    
  self.title(unicode(" Ajout d'une rsistance"))
  self.resizable(width =0, height =0)    
  self.geometry("+200+150")
  self.transient(master =appli)     
  self.protocol('WM_DELETE_WINDOW', self.sortie)
  self.appli =appli
  self.x, self.y = x, y
  self.tag =tag
  spinFr =Frame(self, bd =2, relief =GROOVE)
  Label(spinFr, text =unicode("Valeur de la rsistance :"),
      font =Glob.fontS).pack(side =TOP, padx =5, pady =2)
  Label(spinFr, text= '', width =2).pack(side =LEFT)
  p = [1, 2, 3, 4, 5, 6, 7, 8, 9]
  self.rSp1 =AmpouleOrdinaire(spinFr, eWidth=2, aWidth =15, vList =p, liInd=0)
  self.rSp1.cadre.pack(side =LEFT, pady =3)
  p = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]
  self.rSp2 =AmpouleOrdinaire(spinFr, eWidth=2, aWidth =15, vList =p, liInd=5)
  self.rSp2.cadre.pack(side =LEFT, pady =3)
  p = ["", "0", "00", "000", "0000", "00000", "000000", "0000000"]
  self.rSp3 =AmpouleOrdinaire(spinFr, eWidth=7, aWidth =25, vList =p,
         justify ="w", liInd=1)
  self.rSp3.cadre.pack(side =LEFT, pady =3)
  Label(spinFr, text="ohms", font =Glob.fontS)\
     .pack(side =LEFT)
  spinFr.grid(row =1, column =1, padx =5, pady =5)
  spFr2 =Frame(self, bd =2, relief =GROOVE)
  Label(spFr2, text ="Puissance admissible :", font =Glob.fontS)\
    .pack(side =TOP, padx =5, pady =2)
  Label(spFr2, text ='', width =2).pack(side =LEFT)
  p =["250","500","1000","2000"]
  self.rSp4 =AmpouleOrdinaire(spFr2, eWidth=4, aWidth =25, vList =p, liInd=0)
  self.rSp4.cadre.pack(side =LEFT, pady =3)
  Label(spFr2, text="milliwatts", font =Glob.fontS).pack(side =LEFT)
  spFr2.grid(row =1, column =2, padx =5, pady =5)
  self.orient =StringVar()
  self.orient.set("horizontale")
  orFra =Frame(self)
  Label(orFra, text ="Orientation :", font =Glob.fontS)\
     .pack(side =LEFT, padx =3, pady =2)
  for t in ("horizontale","verticale"):
   Radiobutton(orFra, text =t, variable =self.orient,
      font =Glob.fontS, value =t)\
      .pack(side =LEFT, padx =2)
  Button(orFra, text ="OK", width =4, command =self.sortie,
     font =Glob.fontS).pack(side =LEFT, padx =8, pady =5)
  orFra.grid(row =2, column =1, columnspan =2)
 def sortie(self, evt =None):
  R = float(10*int(self.rSp1.get()) + int(self.rSp2.get()))
  R *= 10**len(self.rSp3.get())
  P ={"250":3,"500":2,"1000":1,"2000":0}[self.rSp4.get()]
  D =self.orient.get()[0]      
  self.appli.dicoD[self.tag] = effacerToutCompl(self.appli.can,
    self.x, self.y, self.tag, val= R, size=P, ori =D)
  self.appli.sousEnsemble()
  self.destroy()
class released(Toplevel):
 def __init__(self, appli, x, y, tag):
  Toplevel.__init__(self)    
  self.title(unicode(" Ajout d'une rsistance variable"))
  self.resizable(width =0, height =0)    
  self.geometry("+200+150")
  self.transient(master =appli)     
  self.protocol('WM_DELETE_WINDOW', self.sortie)
  self.appli =appli
  self.x, self.y = x, y
  self.tag =tag
  spinFr =Frame(self)
  Label(spinFr, text =unicode("Valeur maximale de la rsistance :"),
      font =Glob.fontS).pack(side =TOP, padx =5, pady =2)
  Label(spinFr, text= '', width =2).pack(side =LEFT)
  p = [100, 250, 500, 1000, 2500, 5000, 10000]
  self.rSp =AmpouleOrdinaire(spinFr, eWidth=6, vList =p, liInd=2)
  self.rSp.cadre.pack(side =LEFT)
  Label(spinFr, text="ohms", font =Glob.fontS)\
     .pack(side =LEFT)
  spinFr.pack()
  Label(self, text ="Puissance admissible = 1.5 W",
      font =Glob.fontS).pack(side =LEFT, padx =5, pady =2)
  Button(self, text ="OK", width =4, command =self.sortie,
     font =Glob.fontS).pack(side =LEFT, padx =8, pady =5)
 def sortie(self, evt =None):
  R = float(self.rSp.get())
  self.appli.dicoD[self.tag] =VareffacerToutCompl(self.appli.can,
    self.x, self.y, self.tag, vMax =R)
  self.appli.sousEnsemble()
  self.destroy()
class refchoixAmpereMetre(Toplevel):
 def __init__(self, appli, x, y, tag):
  Toplevel.__init__(self)    
  self.title(" Ajout d'une diode")
  self.resizable(width =0, height =0)    
  self.geometry("+200+150")
  self.transient(master =appli)     
  self.protocol('WM_DELETE_WINDOW', self.sortie)
  self.appli =appli
  self.x, self.y = x, y
  self.tag =tag
  Label(self, text =unicode("Les diodes sont des dispositifs  semi-"+\
   "conducteur qui prsentent des proprits lectriques "+\
   "particulires. Il en existe de nombreux types. "+\
   "Vous pouvez en tester deux ici : les diodes 'de dtection' "+\
   "ou diodes ordinaires, utilises dans de nombreux circuits "+\
   "lectroniques, et les diodes luminescentes (LED), trs "+\
   "apprcies de nos jours comme tmoins lumineux.\n\n"+\
   "Attention : les caractristiques lectriques de ces deux types "+\
   "de diodes sont diffrentes."), wraplength ='9c',
   font =Glob.fontM).pack(padx =5, pady =5)
  fr =Frame(self)
  Label(fr, text ="Choisissez le type :", font =Glob.fontS).\
     grid(row =1, column =1, padx =5, sticky =W)
  self.typ =IntVar()
  Radiobutton(fr, text ="Diode ordinaire", font =Glob.fontS,
       variable =self.typ, value =1).\
       grid(row =2, column =1, padx =5, sticky =W)
  Radiobutton(fr, text ="Diode luminescente", font =Glob.fontS,
       variable =self.typ, value =2).\
       grid(row =3, column =1, padx =5, sticky =W)
  fr.pack(side=LEFT, padx =40, pady =10)
  Button(self, text ="OK", width =4, command =self.sortie,
     font =Glob.fontS).pack(side =RIGHT, padx =20)
  self.typ.set(1)
 def sortie(self, evt =None):
  appli =self.appli
  choix =self.typ.get()
  if choix ==1:
   appli.dicoD[self.tag] =\
     Diode(appli.can, self.x, self.y, self.tag, appli =appli)
  else:
   appli.dicoD[self.tag] =\
     buttonCoords(appli.can, self.x, self.y, self.tag, appli =appli)
  appli.sousEnsemble()
  self.destroy()
class Intendance(Toplevel):
 def __init__(self, appli):
  Toplevel.__init__(self)    
  self.title(" Intendance")
  self.geometry("+200+150")
  self.transient(master =appli)     
  self.protocol('WM_DELETE_WINDOW', self.sortie)
  self.appli =appli
  Label(self, text=unicode("Prfrences, actions d'ensemble"),
     font =Glob.fontP).pack(pady =5)
  self.showIds =IntVar()
  self.whiteBg =IntVar()
  self.lumiApp =IntVar()
  Checkbutton(self, text=unicode("Panneau blanc (pour copies d'cran)"),
     variable =self.whiteBg, font =Glob.fontS,
     command =self.melangerQuest).pack(anchor =W, padx =10)
  Checkbutton(self, text=unicode("Afficher les id. des lments"),
     variable =self.showIds, font =Glob.fontS).\
     pack(anchor =W, padx =10)
  Checkbutton(self, text=unicode("Appareils de mesure 'lumineux'"),
     variable =self.lumiApp, font =Glob.fontS).\
     pack(anchor =W, padx =10)
  Label(self).pack()     
  Button(self,text =unicode("Raliser un exemple de montage"),
      command =self.montage, font =Glob.fontS, width =28).\
      pack(padx =5)
  Button(self,text =unicode("Effacer les lments prsents"),
      command =self.simplifie, font =Glob.fontS, width =28).\
      pack(padx =5)
  Button(self,text =unicode("Quitter VoltaSim"),
      command =self.quitter, font =Glob.fontS, width =28).\
     pack(padx =5)
  Button(self,text ='OK', width =4, command =self.sortie,
     font =Glob.fontS).\
     pack(side =RIGHT, padx =5, pady =5)
  self.showIds.set(Glob.showIds)
  self.lumiApp.set(Glob.lumiApp)
  coulCan = self.appli.can.configure('bg')[-1]
  if coulCan =="white": self.whiteBg.set(True)
 def simplifie(self):
  for id in self.appli.dicoD.keys():
   self.appli.supprimer(id)
  Glob.exampleExists =False
 def montage(self):
  Glob.showIds =(self.showIds.get())     
  Glob.lumiApp =(self.lumiApp.get())
  self.simplifie()
  self.appli.montage()
 def melangerQuest(self):
  can = self.appli.can               
  can.delete(ALL)                    
  Glob.exampleExists =False
  if self.whiteBg.get():
   Glob.coulCan ="white" ; Glob.coulTag ="black"
  else:
   Glob.coulCan =Glob.coulCanBase ; Glob.coulTag ='white'
  can.configure(bg =Glob.coulCan)
  return
  if Glob.coulCan =="white":
   ma =20
   for x in range(ma, 1000, ma):
    can.create_line(x,0,x,1200, fill ='cyan',
      tag ='fond', stipple ="gray50")
   for y in range(ma, 1000, ma):
    can.create_line(0,y,1600,y, fill ='cyan',
      tag ='fond',  stipple ="gray50")
   can.create_line(60,0,60,1200, fill ='red', tag ='fond')
 def sortie(self, evt =None):
  Glob.showIds =(self.showIds.get())     
  Glob.lumiApp =(self.lumiApp.get())
  self.appli.sousEnsemble()
  self.destroy()
 def quitter(self):
  self.appli.sauverRepQCM()
class suiteControleLic(Toplevel):
 def __init__(self, boss):
  Toplevel.__init__(self, bg ="grey70")
  self.boss =boss
  self.overrideredirect(1)       
  self.transient(boss)           
  fra =Frame(self, bd =4, relief =GROOVE)
  self.img =PhotoImage(file ="cocci2.gif")
  Label(fra, image =self.img).pack(pady =8)
  Label(fra, text = unicode("Merci de vous intresser  ce logiciel,\n"+\
   "dont vous n'valuez cependant ici qu'une\nversion de "+\
   "dmonstration limite.\n\nPour toute information concernant la version "+\
   "complte,\nveuillez consulter un de nos distributeurs agrs.\n"+\
   "Vous pourrez trouver leurs coordonnes dans l'aide,\n"+\
   " la rubrique 'Distribution du logiciel'.\n"), font =Glob.fontM).\
   pack(padx =10, pady =4)
  fra.pack(padx =10, pady =15)
  boss.secWinPresent =True 
  scrX, scrY = self.winfo_screenwidth(), self.winfo_screenheight()
  self.geometry("+%d+%d" % (scrX/2 -200, scrY/2-100))
 def traceGraphe(self, duree):
  self.after(duree, self.quit)
 def quit(self, event =None):
  self.destroy()
  self.boss.sousEnsemble()
class secWinDestroyed(Toplevel):
 def __init__(self, appli):
  Toplevel.__init__(self)
  self.geometry("770x550+20+20")
  self.protocol('WM_DELETE_WINDOW', self.sortie)
  self.appli =appli
  fraSup =Frame(self)
  self.lab =[]
  for u in range(4):
   self.lab.append(Label(fraSup))
   self.lab[-1].pack(side =LEFT, padx =15, pady =6)
  fraSup.pack()
  fraTxt =Frame(self, bd =2, relief =SUNKEN)
  self.st =Text(fraTxt, font =Glob.fontN, bg ='ivory', bd =1,
       cursor ="top_left_arrow", width =100, height =5,
       padx =10, pady =8,
       selectbackground ='ivory',
       selectforeground ='black')
  scroll =Scrollbar(fraTxt, bd =1, command =self.st.yview)
  self.st.configure(yscrollcommand =scroll.set)
  scroll.pack(side =RIGHT, expand =YES, fill =Y, padx =2, pady =2)
  self.st.pack(expand =YES, fill =BOTH, padx =2, pady =2)
  fraTxt.pack(expand =YES, fill =BOTH, padx =4, pady =4)
  self.newPage =True
  self.commencer()
 def commencer(self):
  self.title(" Guide de travail")
  self.lab[0].configure(text =unicode("VoltaSim - "+\
     "Simulation de circuits lectriques"),
     font =Glob.fontT, fg ='Navy')
  Label(self, text ='', font ='helvetica 6').pack()        # rserve 1 espace en bas
  of = open(Glob.docFile, 'r')
  self.lignes = of.readlines()
  of.close()
  for n, ligne in enumerate(self.lignes):
   self.lignes[n] = unicode(ligne)
  self.chargePage(1)
  self.st.configure(state =DISABLED)
 def deplaceFils(self, evt, lien):
  if lien =="quit":        
   self.sortie() ; return
  elif lien =="qcm":
   self.appli.dessineBout()
   self.destroy() ; return
  self.st.configure(state =NORMAL)
  self.chargePage(lien)
  self.st.configure(state =DISABLED)
 def chargePage(self, page):
  if self.newPage:
   self.st.delete('0.0',END)
   self.ima =[]       
  bp ="\\%s\\" % page
  lb =len(bp)
  nb =0
  nt =True
  for li in self.lignes:
   if nt :
    if li[:lb] != bp: continue
    else:
     cq = li[lb:]   
     cq =cq.split(',')
     if len(cq) > 3:  
      self.codeQcm = cq
     nt =False ; continue
   if li[0] =='#' : continue       # lignes  ignorer
   if li[0] =="\\": break          # fin de page atteinte
   if li[0] =="" :
    p2 = li.find('')
    self.ima.append(PhotoImage(file = li[1:p2-2]))
    self.st.image_create(END, image =self.ima[-1])
    continue
   i, noBind, k = 0, True, 0
   while 1:
    p0 = i
    p1 = li.find("@", i)
    if p1 < 0:
     if p0 >0 : self.st.insert(END, li[p0:])
     break
    self.st.insert(END, li[p0:p1])
    i = p1 +1
    p2 = li.find("@", i)
    i = p2 +1
    p3 = li.find("@", i)
    i = p3 +1
    balise ="b%s" % nb
    textCli = li[p1+1:p2] ; lien =li[p2+1:p3]
    self.st.tag_configure(balise, foreground ='dark violet',
          font =Glob.fontB, underline =True)
    self.st.tag_bind(balise, '<Button-1>',
       lambda evt, arg=lien : self.deplaceFils(evt, arg))
    self.st.insert(END, textCli, balise)
    nb += 1
    noBind =False       
    k += 1
    if k > 15: break
   if noBind:
    self.formate(li)       
 def formate(self, li):
  gras, indi, titr, grec =[], [], [], []
  idep =self.st.index(END)   
  i =idep.find('.')
  idep = int(idep[:i]) -1
  n =0
  for pos, car in enumerate(li):
   for cs, lb in (('~', gras), ('|', indi),
         ('$', titr), ('', grec)):
    if car == cs:
     lb.append(pos -n) ; n += 1
  for c in ('~', '|', '$', ''):
   li = li.replace(c,"")
  self.st.insert(END, li)
  self.st.tag_configure('bold', foreground ='royal blue',
          font =Glob.fontB)
  self.st.tag_configure('indi', foreground ='blue',
          font =Glob.fontR)
  self.st.tag_configure('titr', foreground ='brown',
          font =Glob.fontP)
  self.st.tag_configure('grec', foreground ='black',
          font ='symbol 13')
  for lb, balise in ((gras,'bold'), (indi,'indi'),
         (titr,'titr'), (grec,'grec')):                    
   for i in range(0, len(lb), 2):
    g1, g2 = lb[i], lb[i+1] 
    self.st.tag_add(balise, "%s.%s" % (idep,g1),
          "%s.%s" % (idep,g2))
 def sortie(self, evt =None):
  self.appli.startQCM()
  self.destroy()
class helpWinDestroyed(secWinDestroyed):
 def __init__(self, appli):
  secWinDestroyed.__init__(self, appli)        
  boutons =("1","2","3","4","Rejet", "Continuer", "Terminer")
  Label(self, text ='').pack(side =LEFT, padx =10)
  Label(self, text ='').pack(side =RIGHT, padx =10)
  for n, bout in enumerate(boutons):
   if n >4 : w =10
   else: w =5
   b = Button(self, text =bout, width =w,
       command =lambda arg =bout : self.clignoteur(arg))
   if len(bout) >5: b.pack(side =RIGHT)
   else : b.pack(side =LEFT, pady =5)
  self.okToCont =True    
 def commencer(self):
  self.title(unicode(" Test d'auto-valuation"))
  self.lab[0].configure(text =unicode("VoltaSim - valuation"),
         font =Glob.fontT, fg ='Navy')
  of = open(Glob.qcmFile, 'r')
  self.lignes = of.readlines()
  of.close()
  for n, ligne in enumerate(self.lignes):
   self.lignes[n] = unicode(ligne)
  nbQ = 0
  for li in self.lignes:
   if li[0:12] == "\\Questions:\\":  nbQ =0
   if li[0] == "\\": nbQ += 1
  nbQ /=2
  Glob.listeQ = range(1, nbQ +1)
  self.Multimeter()
  self.nQtot =nbQ
  self.showPassScore()       
  self.dejaRep =False
  self.fini =True
  self.iQ = -2
  self.chargePage("a2")
  self.st.configure(state =DISABLED)
  self.startTime =int(time.time())
 def clignoteur(self, rep):
  if Glob.demoOuNon != 16071949 and self.iQ % 7 == 2:
   st = suiteControleLic(self.appli)
   st.traceGraphe(3000 + self.iQ*300)
  if rep in ('1','2','3','4','5','Rejet'):
   if self.iQ < 0 : return        
   if self.dejaRep : return       
   self.newPage =False            
   self.st.configure(state ="normal")
   self.st.insert(END,'\n')
   sol =self.codeQcm[1]               
   if sol == '5': sol ='Rejet' 
   nQ = Glob.listeQ[self.iQ]          
   stat = Glob.dicoQ.get(nQ, [0, 0])  
   if rep == sol:
    t ="$%s :$ ~rponse correcte~" % rep
    if stat[0]:                
     del(Glob.listeQ[self.iQ]) 
    stat[0] += 1
   else:
    t ="$%s :$ ~rponse fausse~. " % rep +\
       "La rponse correcte tait : $%s$." % sol
    stat[0] = 0
   stat[1] += 1           
   Glob.dicoQ[nQ] =stat
   self.dejaRep =True     
   Glob.nRepQ +=1
   self.showPassScore()       
   self.formate(unicode(t) +"\n\n")
   self.chargePage("s%s" % nQ)
   self.st.configure(state =DISABLED)
   self.newPage =True     
  elif rep =='Continuer':
   if not self.okToCont: return
   if self.iQ < 0:        
    self.st.configure(state =NORMAL)
    self.chargePage("a%s" % abs(self.iQ +1))
    self.st.configure(state ="disabled")
    self.iQ += 1       
    if self.iQ <0 : return
   self.fini =False
   nbQ =len(Glob.listeQ)
   if nbQ ==0:            
    self.terminer()     
    return
   self.iQ +=1             
   if self.iQ >= nbQ:     
    self.iQ =0
    Glob.passeQ +=1
    self.Multimeter()
   self.dejaRep =False
   self.st.configure(state =NORMAL)
   self.chargePage(Glob.listeQ[self.iQ])
   self.st.configure(state =DISABLED)
  elif rep =='Terminer':
   if self.fini: self.sortie() ; return
   self.terminer()
 def terminer(self):
  score =0
  for stat in Glob.dicoQ.values():
   if stat[0]: score += 1
  Glob.dureeQ += int(time.time()) - self.startTime
  tt =int((Glob.dureeQ + 30)/60)     
  self.st.configure(state ="normal")
  self.st.delete("0.0", END)
  self.formate(unicode("$Rcapitulatif du test$ \n\n"))
  t ="Le test comporte %s questions.\n" % self.nQtot
  self.formate(unicode(t))
  t ="Vous y avez fourni au total %s rponses,\n" % Glob.nRepQ
  self.formate(unicode(t))
  t = "et consacr au questionnaire un temps de "+\
   "%s secondes (soit env. %s min.).\n" % (Glob.dureeQ, tt)
  self.formate(unicode(t))
  t ="Nombre de passes (visions successives du questionnaire " +\
     "entier) : %s.\n" % Glob.passeQ
  t = t +"Vous avez rpondu correctement  %s question(s) " % score
  t = t +" sur un total de %s.\n" % self.nQtot
  self.formate(unicode(t))
  for k, stat in Glob.dicoQ.items():
   t = "Q. %s : " % k
   if stat[1] ==0: t =t +"pas de rponse."
   else:
    t =t+"%s essai(s). " % stat[1]
    if stat[0] ==0: t =t +"Non russie."
    else: t =t +"Russie %s fois." % stat[0]
   self.formate(unicode(t) +"\n")
  t ="\nRemarque : les questions sont listes ici dans l'ordre du "+\
     "fichier de rfrence,\net non dans l'ordre o elles apparaissent "+\
     "au cours du test."
  self.formate(unicode(t))
  self.st.configure(state =DISABLED)
  self.okToCont =False       
  self.fini =True
 def Multimeter(self):
  lq = Glob.listeQ[:]   
  for q in lq:
   stat = Glob.dicoQ.get(q, [0, 0])  
   if stat[0] > 1:            
    Glob.listeQ.remove(q)  
  nbQ = len(Glob.listeQ)
  for i in range(nbQ):
   a, b = randrange(nbQ), randrange(nbQ)
   Glob.listeQ[a], Glob.listeQ[b] = Glob.listeQ[b], Glob.listeQ[a]
 def showPassScore(self):
  score =0
  for stat in Glob.dicoQ.values():
   if stat[0]: score += 1
  nQrest = len(Glob.listeQ)
  self.lab[1].configure(text ="Passe : %s" % Glob.passeQ,
       width =12, bg ='ivory', relief =SUNKEN)
  self.lab[2].configure(text ="Score : %s/%s" % (score, self.nQtot),
       width =13, bg ='ivory', relief =SUNKEN)
  self.lab[3].configure(width =19, bg ='ivory', relief =SUNKEN,
   text =unicode("Rp.: %s - Q.rest.: %s" % (Glob.nRepQ, nQrest)))
class onOff(Toplevel):
 def __init__(self, appli):
  Toplevel.__init__(self)    
  self.title(unicode("  propos de %s " % Glob.nomProgVer))
  self.resizable(width =0, height =0)    
  self.transient(master =appli)     
  self.protocol('WM_DELETE_WINDOW', self.sortie)
  self.appli =appli
  Label(self).pack()     
  self.ima = PhotoImage(file = "cocci2.gif")
  fra = Frame(self, bd =2, relief =GROOVE)
  Label(fra, image =self.ima).pack(pady =2)
  Label(fra, text =Glob.nomProgVer, font =Glob.fontP, fg ='navy',
    width =18).pack(pady =2)
  fra.pack(pady =5)        
  Label(self, text =unicode("Programme entirement dvelopp avec Python 2.3\n"+\
     "Utilise la bibliothque graphique Tkinter\n" +\
     "( Voir : http://www.python.org )"),
     font =Glob.fontM).pack(padx =25)    
  Label(self, text =unicode("(C) 7P Soft - Lige, Belgique, 1986-2004.\n"+\
     "Tous droits rservs."), font =Glob.fontG).pack()    
  Label(self, text =unicode("La liste des distributeurs "+\
     "agres\npeut tre consulte dans l'aide en ligne.\n\n"+\
     "Tit. de licence : %s" % (appli.licensedTo)),
     font =Glob.fontM).pack()    
  Button(self, text ='OK', width =8, command =self.sortie).pack(pady =9)
  scrX, scrY = self.winfo_screenwidth(), self.winfo_screenheight()
  self.geometry("+%d+%d" % (scrX/2 -200, scrY/2-180))
 def sortie(self, evt =None):
  self.appli.sousEnsemble()
  self.destroy()
class newDispId(Toplevel):
 def __init__(self, boss, scrX, scrY):
  Toplevel.__init__(self, bg ="black")
  self.boss = boss
  larg, haut = 715, 560
  self.geometry("+%s+%s" % (scrX/2-larg/2, scrY/2-haut/2+25))
  self.overrideredirect(1)       
  self.transient(boss)           
  can = Canvas(self, width =larg, height =haut, bg='steel blue',
      bd =6, relief =RAISED)
  imFile = "voltasim.gif"
  self.imTk1 =PhotoImage(file =imFile)  
  can.create_image(4, 4, anchor=NW, image =self.imTk1)
  imFile = "cocci2.gif"
  self.imTk2 =PhotoImage(file =imFile)
  can.create_image(50, haut -25, anchor =CENTER, image =self.imTk2)
  can.create_text(70, haut-20, anchor =W, font =Glob.fontR,
   text =unicode("(C) 7P Soft - 2004, Lige, Belgique. Tous droits rservs"))
  imFile = "logoG5c.gif"
  self.imTk3 =PhotoImage(file =imFile)
  can.create_image(larg -90, haut -25, anchor =CENTER, image =self.imTk3)
  can.pack()
  self.bind("<Button-1>", self.quit)
 def choixVoltMetre(self, duree):
  self.after(duree, self.quit)
 def quit(self, event =None):
  self.destroy()
  self.boss.controleLicence()
class switchPol(Frame):
 def __init__(self):
  Frame.__init__(self)
  scrX, scrY = self.winfo_screenwidth()-30, self.winfo_screenheight()-60
  self.master.geometry("%sx%s+10+10" %(scrX,scrY))
  self.master.title(" "+ Glob.nomProgVer)
  self.master.protocol('WM_DELETE_WINDOW', self.sauverRepQCM)
  self.master.option_readfile('optionDB')
  sw = newDispId(self, scrX, scrY)
  sw.choixVoltMetre(10000)             
  self.tBar =cursorReleased(self)
  self.tBar.pack(expand =YES, fill =X)
  self.pan = Panneau(self)
  self.pan.pack(expand =YES, fill=BOTH)
  self.pack()
  self.master.bind('<Control-Z>', self.refresh)
  self.can =self.pan.can     
  self.secWinPresent =True   
  self.helpWindow =None      
  self.exampleExists =False  
  self.dicoD ={}             
  self.fils =[]              
  self.ajouts =0             
  if Glob.startCircuit: self.montage()        
 def montage(self):
  if Glob.exampleExists: return
  pos =((100,170), (97,350), (250,35), (450,150),
     (650,280), (500,330), (250,450), (260,220))
  for n in range(8):
   tag = chr(n +65)     
   x, y = pos[n] 
   if n in (0, 1, 4):
    if n ==4: sens =-1
    else: sens =1
    self.dicoD[tag] =supprDispo(self.can, x, y, tag,
        volt =1.5, sens =sens, appli =self)
   elif n == 2:
    self.dicoD[tag] =addTool(self.can, x, y, tag)
   elif n == 3:
    self.dicoD[tag] =tracerFils(self.can, x, y, tag)
   elif n == 5:
    self.dicoD[tag] =suppriConnex(self.can, x, y, tag, 1)
   elif n == 6:
    self.dicoD[tag] =effacerToutCompl(self.can, x, y, tag,
       val =18., size =1)
   elif n == 7:
    self.dicoD[tag] =suppriConnex(self.can, x, y, tag, 0)
  liens =((("A","n"),("B","p")), (("A","p"),("C","n")),
    (("C","p"),("D","n")), (("D","p"),("E","p")),
    (("E","n"),("F","n")), (("F","p"),("G","p")),
    (("G","n"),("B","n")), (("H","n"),("G","p")),
    (("H","p"),("G","n")))
  for couple in liens:
   self.lier(couple[0], couple[1])
  Glob.exampleExists =True
 def ajouter(self, item, tool):
  if self.secWinPresent: return 
  tag =self.Application()      
  if tag ==None:
   tkMessageBox.showwarning(" Saturation",
    unicode("Le nombre maximum de composants est atteint.\nSi vous "+\
    "souhaitez encore installer des lments, vous devez commencer "+\
    "par en enlever quelques-uns parmi ceux qui sont en place."))
   return
  x, y = 100 +randrange(600), 50 +randrange(400)
  if item =="res":
   goTo(self, x, y, tag)
   self.secWinPresent =True
  elif item =="bak":
   Intendance(self)
   self.secWinPresent =True
  elif item =="inf":
   onOff(self)
   self.secWinPresent =True
  elif item =="led":
   refchoixAmpereMetre(self, x, y, tag)
   self.secWinPresent =True
  elif item =="var":
   released(self, x, y, tag)
   self.secWinPresent =True
  elif item =="swi":
   showInfos(self, x, y, tag)
   self.secWinPresent =True
  elif item =="hlp":
   if not self.helpWindow: 
    self.helpWindow = secWinDestroyed(self)
   else:
    self.helpWindow.lift()
  elif item =="gen":
   self.dicoD[tag] =DiodeLuminescente(self.can, x, y, tag)
  elif item =="bul":
   self.dicoD[tag] =tracerFils(self.can, x, y, tag)
  elif item =="pil":
   self.dicoD[tag] =supprDispo(self.can, x, y, tag, volt =1.5, appli =self)
  elif item =="vol":
   self.dicoD[tag] =suppriConnex(self.can, x, y, tag, 0)
  elif item =="amp":
   self.dicoD[tag] =suppriConnex(self.can, x, y, tag, 1)
  else:
   self.dicoD[tag] =Dispositif(self.can, x, y, tag)
 def sousEnsemble(self):
  self.secWinPresent =False
 def startQCM(self):
  self.helpWindow =None
 def controleLicence(self):
  try:
   ofi =open("pel"+"ouse.j"+"pg", "rb")
   ofi.seek(6789)
   li1 = ofi.readline()
   li2 = ofi.readline()
   ofi.close()
  except:
   tkMessageBox.showinfo(" Erreur",
   unicode("Informations de licence introuvables.\n"\
   "Veuillez rinstaller le logiciel."))
   return
  try:
   prefix =int(li1[0:3])
   self.licenseNum =int(li1[3:-1]) - 254482556
   self.licensedTo =li2[0:-1] 
  except:
   ajusteRi(self)
  else:
   self.styleChange()
 def styleChange(self):
  n = 47
  verif = 0
  for c in self.licensedTo:
   n += 2003      
   verif += ord(c) *n
  verif = 985326417 - verif
  if verif == self.licenseNum:
   Glob.demoOuNon = 16071949
   self.temoins()
  else:
   rep = tkMessageBox.askquestion(unicode(" Version de dmonstration"),
    unicode("Cette copie de VoltaSim a t initialise en "\
    "version de dmonstration.\n"\
    "Dsirez-vous la dbrider maintenant ?\n"\
    "(Vous devrez entrer vos informations de licence)"))
   if rep in ('yes', True):
    ajusteRi(self)
   else:
    self.licensedTo =unicode("Version de dmonstration")
  self.secWinPresent =False      
 def dessineBout(self):
  self.helpWindow =helpWinDestroyed(self)
 def temoins(self):
  rep = tkMessageBox.askquestion(unicode(" Rcupration d'une sauvegarde"),
   unicode("Si vous avez dj travaill auparavant avec VoltaSim, "+\
   "vous souhaitez peut-tre rimporter les rponses que vous "+\
   "avez dj fournies au questionnaire d'auto-valuation."))
  if rep in ('no', False): return
  while 1:
   path = tkFileDialog.askopenfilename(defaultextension =".cbv",
      filetypes =(("Fichiers VoltaSim",".cbv"),
         ("Tous les fichiers","*")),
      title =unicode(" Fichier mmo.  rcuprer :"))
   if len(path) ==0: return
   ofi =open(path, 'r')
   lignes =ofi.readlines()
   ofi.close()
   rep = tkMessageBox.askquestion(" Confirmation",
      unicode("Propritaire de ces donnes :\n%s\nD'accord ?" % (lignes[3])))
   if rep in ('yes', True): break
  for n, li in enumerate(lignes):
   d = li.split()
   if n in (0,1,2,3,7,8): continue      
   elif n ==4: Glob.dureeQ = int(d[0])
   elif n ==5: Glob.nRepQ = int(d[0])
   elif n ==6: Glob.passeQ = int(d[0])
   else: Glob.dicoQ[int(d[0])] =[int(d[1]), int(d[2])]
 def sauverRepQCM(self):
  if Glob.nRepQ ==0: self.terminer() ; return
  rep = tkMessageBox.askquestion(unicode(" Sauvegarde de vos rponses  l'auto-test"),
   unicode("Vous avez fourni %s rponses au test d'auto-valuation." %\
    (Glob.nRepQ) + "\nSouhaitez-vous les mmoriser, afin de pouvoir "+\
   "restaurer votre score actuel lors d'une sance de "+\
   "travail ultrieure ?"))
  if rep in ('no', False): self.terminer() ; return           
  path = tkFileDialog.asksaveasfilename(defaultextension =".cbv",
      filetypes =(("Fichiers VoltaSim",".cbv"),
         ("Tous les fichiers","*")),
      title =unicode(" Fichier mmo.  sauvegarder :"))
  if len(path) ==0: return
  perso =tkSimpleDialog.askstring(unicode(" Vos coordonnes personnelles"),
      unicode("Veuillez entrer votre Nom et le sigle de votre classe, s.v.p."))
  ofi =open(path, 'w')
  ofi.write("QM63 *** Sauvegarde de rponses fournies "+\
       " un test ACQC\n")
  ofi.write("Logiciel VoltaSim - (C) G.swinnen 1993-2004 "+\
       "(Lige, Belgique)\n")
  ofi.write("------------------------------------------------\n")
  ofi.write(perso +"\n")
  ofi.write("%s secondes ont t consacres au test.\n" %\
        Glob.dureeQ)
  ofi.write("%s rponses ont t fournies au total.\n" % Glob.nRepQ)
  ofi.write("%s passe(s) du test entier.\n" % Glob.passeQ)
  ofi.write("Pour chaque question (dans l'ordre du fichier ressource),\n")
  ofi.write("nombre de rponses correctes et nombre de tentatives :\n")
  for k, v in Glob.dicoQ.items():
   ofi.write("%s %s %s\n" % (k, v[0], v[1]))
  ofi.close()
  self.terminer()
 def terminer(self):
  tkMessageBox.showinfo("Fermeture de VoltaSim",
         unicode(" bientt, peut-tre ? ..."))
  self.master.destroy()
 def Application(self):
  self.ajouts +=1
  if Glob.demoOuNon != 16071949 and self.ajouts % 4 == 0:
   st = suiteControleLic(self)
   st.traceGraphe(3000 + self.ajouts*300)
  for n in range(26):
   tag = chr(n +65)     
   if tag in self.dicoD.keys(): continue
   else: return tag
  return None            
 def lier(self, n1, n2):
  if len(n1) <2 or len(n2) <2: return  
  if n1[0] == n2[0]: return          
  d1 = self.dicoD[n1[0]]             
  x1, y1 = d1.coordBorne(n1[1])      
  d2 = self.dicoD[n2[0]]             
  x2, y2 = d2.coordBorne(n2[1])      
  s1 =n1[0] +n1[1]       
  s2 =n2[0] +n2[1]
  lb1 ={'n':d1.bNeg, 'p':d1.bPos}[n1[1]]   
  lb2 ={'n':d2.bNeg, 'p':d2.bPos}[n2[1]]
  lc1, lc2 =lb1[:], lb2[:]       
  if not s2 in lb1: lb1.append(s2)
  else: return       
  if not s1 in lb2: lb2.append(s1)
  else: return       
  lc1.append(s1) ; lc2.append(s2)
  filMod =[False]*len(self.fils)     
  for s,lb,lc in ((s2,lb1,lc1), (s1,lb2,lc2)):
   for id in lb:
    idd, idb =id[0], id[1]
    d =self.dicoD[idd]                     
    liBo ={'n':d.bNeg, 'p':d.bPos}[idb]     # liste de connex.
    for i in lb:
     if i == id: continue   
     if not i in liBo: liBo.append(i)
   for n, fil in enumerate(self.fils):
    if not fil : continue      
    if filMod[n]: continue     
    for liEx in (fil[1], fil[2]):
     if s in liEx:
      liEx += lc     
      filMod[n] =True
  tag ="@%s" % len(self.fils)
  self.fils.append([self.can.create_line(x1, y1, x2, y2,
        width =9,
        fill =Glob.coulCan, tags =tag),
       lc1, lc2, (n1+n2),
        self.can.create_line(x1, y1, x2, y2,
        width =3, fill =Glob.coulFil, tags =tag)])
  d1.dilateBorne(n1[1])
  d2.dilateBorne(n2[1])
  self.can.lower(tag)    
  self.refresh()
 def TestQCM(self, idFil):
  fil = self.fils[idFil]
  if fil ==None: return
  for liEx, liOp in ((fil[1],fil[2]), (fil[2],fil[1])):
   for id in liEx:
    idd, idb =id[0], id[1]
    d =self.dicoD.get(idd, None)            
    if d ==None: continue                  
    liBo ={'n':d.bNeg, 'p':d.bPos}[idb]     # liste de connex.
    for c in liOp:
     if c in liBo: liBo.remove(c)
  for liEx, liOp in ((fil[1],fil[2]), (fil[2],fil[1])):
   liOpp =liOp[:]     
   for n,f in enumerate(self.fils):
    if not f: continue
    for lc in (f[1], f[2]):
     if AjoutInterrupteur(liOpp, lc):
      for c in liOpp: 
       if c in lc: lc.remove(c)
  id1, b1, id2, b2 =fil[3][0:4]   
  self.dicoD[id1].recupQCM(b1)
  self.dicoD[id2].recupQCM(b2)
  self.can.delete("@%s" % idFil)
  self.fils[idFil] =None
 def supprimer(self, idis):
  if not self.dicoD.has_key(idis): return    
  disp =self.dicoD[idis]
  if disp.typ =='sw2':
   self.adapterAuDispo(disp.swcId)
  self.adapterAuDispo(idis)
  self.refresh()
 def adapterAuDispo(self, idis):
  if not self.dicoD.has_key(idis): return    
  for n, fil in enumerate(self.fils):
   if fil ==None: continue
   e1 =fil[3][0] +fil[3][1]
   e2 =fil[3][2] +fil[3][3]
   for bo in (idis +"n", idis +"p"):    
    if bo == e1 or bo == e2:
     self.TestQCM(n)
  self.can.delete(idis)
  del(self.dicoD[idis])
 def inverser(self, idis):
  self.dicoD[idis].inverser()
 def choix1(self, idd, dx, dy):
  self.dicoD[idd].x += dx 
  self.dicoD[idd].y += dy
 def print_dTemp(self, idd, dx, dy):
  disp =self.dicoD[idd]      
  if disp.typ =='sw2': id2 =disp.swcId     # id du switch complm.
  else: id2 =''
  for liBo in (disp.bNeg, disp.bPos):
   for id in liBo:
    idc =id[0]     
    for fil in self.fils:      
     if not fil: continue   
     tdr =fil[3]            
     if (idd in tdr or id2 in tdr) and idc in tdr:
      da =self.dicoD[tdr[0]]      
      ca =da.coordBorne(tdr[1])
      db =self.dicoD[tdr[2]]
      cb =db.coordBorne(tdr[3])
      self.can.coords(fil[0], ca[0],ca[1], cb[0],cb[1])
      self.can.coords(fil[4], ca[0],ca[1], cb[0],cb[1])
 def refresh(self, evt =None):
  dicoTemp = {}      
  self.nGen =0
  approx =1
  for idd, disp in self.dicoD.items():
   dicoTemp[idd] ={"R":disp.R, "E":disp.E,
       "bPos":disp.bPos[:],
       "bNeg":disp.bNeg[:]}
   if disp.E != None: self.nGen += 1    
   if disp.typ =='led' or disp.typ =='dio': approx =20
   if disp.typ =='bul' and approx ==1: approx =5
  irres =False               
  for z in range(approx):    
   self.dTemp = deepcopy(dicoTemp)
   r = self.calculs()     
   if r ==0: break        
   intensites ={}
   for idd in dicoTemp.keys():
    intensites[idd] =0.0
   if r ==1:              
    for idd, I in self.inten.items():
     intensites[idd] += I            
   if r < 0:               
    for idd, disp in self.dicoD.items():
     if disp.E ==None: continue         
     self.dTemp = deepcopy(dicoTemp)
     for i, dt in self.dTemp.items():
      if i == idd: continue
      dt["E"] =None
     r =self.calculs()
     if r ==0 or r >1: irres =True ; r ==0 ; break                   
     for idd, I in self.inten.items():
      intensites[idd] += I
   if r ==0: break        
   for idd, I in intensites.items():
    disp =self.dicoD[idd]
    U = disp.R * I
    if disp.E: U =disp.E -U    
    disp.annulerSel(U =U, I =I)
   for idd, disp in self.dicoD.items():
    disp.refaddToolCompl()
    dicoTemp[idd]["R"] =disp.R
  self.infos =[]  
  ok =True
  if self.genPd:
   tkMessageBox.showwarning(" Erreur",
    unicode("Vous ne pouvez connecter en parallle que des piles "+\
    "de FEM identique, dans le mme sens."))
   ok =False
  if len(self.dTemp) >1:
   tt ="Le circuit est ouvert, ou trop complexe ???"
   ok =False
  if self.genCC:
   tt ="Gnrateur en court-circuit."
   ok =False
  if self.genDec:
   tt ="Gnrateur dconnect ou en court-circuit."
   ok =False
  if irres:
   tt ="Circuit trop complexe."
   ok =False
  if ok:
   tt ="OK" ; fg ='#00B000'
   self.infos.append("Simplifications effectues pour calculer Rq :")
   self.assoc.reverse()
   for ass in self.assoc:
    d1, d2, op = ass[0], ass[3], ass[1]
    if op =="-":
     d3 =("non connect", "en court-circuit")[int(ass[3])]
     self.infos.append("Retrait de %s : %s" % (d1, d3)) 
    elif op =="+":
     rr =ass.split(",")
     self.infos.append("Ajout de %s  %s. FEM:%6.2f Volts, R:%6.2f Ohms" %\
         (d2, d1, float(rr[4]), float(rr[1])+float(rr[2])))
    elif op =="#":
     rr = ass.split(",")
     R1, R2, = float(rr[1]), float(rr[2])
     Re = 1/(1/R1 + 1/R2) 
     self.infos.append("Assoc. parallle de %s avec %s. FEM:%6.2f V, R:%6.2f Ohms" %\
          (d2, d1, float(rr[4]), Re))
  else:
   fg ='#DD0000'       # rouge sombre
   for disp in self.dicoD.values():
    disp.annulerSel(U =0, I =0)
  self.tBar.message(unicode(tt), fg, cligno = (not ok))  
  for disp in self.dicoD.values():
   disp.refresh()        
 def effacerTout(self):
  print "---------"
  for i in self.infos:
   print i
 def AjoutDiode(self):
  for k, v in self.dTemp.items():
   print "%s: %s,%s" % (k, v["bPos"], v["bNeg"]),
  print
 def SplashWindow(self, idd):
  for id, d in self.dTemp.items():
   for lb in (d["bPos"], d["bNeg"]):
    for i in (idd+"n", idd+"p"):
     while 1:
      if i in lb: lb.remove(i)
      else: break
 def calculs(self):
  self.genPar =0     
  self.assoc =[]     
  self.inten ={}     
  while 1:
   if self.APropos(): break
  if self.genPd or self.genCC or self.genDec: return 0
  if len(self.dTemp) >1: return -1
  if len(self.dTemp) ==0: return
  dr =self.dTemp.values()[0]
  Re, FEM =dr['R'], dr['E']
  if FEM ==None : return 0           
  if Re < Glob.riGen *6: self.genDec =True; return 0
  idG =self.dTemp.keys()[0]
  nPar =self.genPar +1       
  riG =Glob.riGen*(self.nGen -nPar + 1./nPar)
  Ir =FEM/Re                 
  Ur =FEM -Ir*riG            
  self.assoc.reverse()
  self.inten[idG] = Ir            
  for ass in self.assoc:
   d1, d2, op = ass[0], ass[3], ass[1]
   if op =="-": self.inten[d1] =0
   elif op =="+":
    rr =ass.split(",")
    sens =int(rr[3])       
    self.inten[d2] =self.inten[d1]*sens
   elif op =="#":
    rr = ass.split(",")
    R1, R2, sens = float(rr[1]), float(rr[2]), int(rr[3]) 
    self.inten[d2] =self.inten[d1]*(1-R2/(R1+R2))*sens
    self.inten[d1] =self.inten[d1]*(1-R1/(R1+R2))
  return 1       
 def APropos(self):
  self.genDec, self.genCC, self.genPd = False, False, False
  RiGm =Glob.riGen * 5   
  for idd, disp in self.dTemp.items():
   for liBo in (disp["bNeg"], disp["bPos"]):
    if len(liBo) == 0:       
     if disp["E"] !=None: self.genDec =True ; continue
     del self.dTemp[idd]    
     self.SplashWindow(idd)
     self.assoc.append("%s-=0" % idd) 
     return False
  for idd, disp in self.dTemp.items():
   bop =idd +'n'        # id de la borne n
   if bop in disp["bPos"]:     # => court-jus
    if disp["E"] !=None:
     if disp['R'] < RiGm: self.genCC =True
     continue
    del self.dTemp[idd]    
    self.SplashWindow(idd)
    self.assoc.append("%s-=1" % idd) 
    return False
  for idd, disp in self.dTemp.items():
   for sic,sop,lb in (("n","p",disp["bNeg"]), ("p","n",disp["bPos"])):
    if len(lb) == 1:           
     idc =lb[0][0]          
     if idc == idd: continue 
     sbc =lb[0][1]          
     sbo ={"n":"p", "p":"n"}[sbc]  # signe borne oppose                                        
     dc =self.dTemp[idc]    
     if sic ==sbc: sens =-1
     else: sens =1  
     lbodc ={'p':dc["bPos"], 'n':dc["bNeg"]}[sbo]                    
     if dc["E"] !=None and disp["E"] !=None:
      if idd+sop in lbodc \
      and dc['R'] < RiGm and disp['R'] < RiGm:
       continue
      disp["E"] += dc["E"]*sens
     if dc["E"] !=None and disp["E"] ==None:
      disp["E"] = dc["E"]*sens
     diR, Fem = disp["R"], disp["E"]
     if Fem==None: Fem =0 
     disp["R"] = diR + dc["R"]   
     if sic =='n': disp["bNeg"] =lbodc
     else: disp["bPos"] =lbodc
     for id in lbodc:
      d =self.dTemp[id[0]]
      b ={"n":d["bNeg"], "p":d["bPos"]}[id[1]]
      for i in b:
       if i ==idc+sbo:
        b.remove(i)
        b.append(idd+sic)
     self.assoc.append("%s+=%s,%s,%s,%s,%s" %\
           (idd, idc, diR, dc["R"], sens, Fem)) 
     del self.dTemp[idc]    
     return False
  for idd, disp in self.dTemp.items():
   for id in disp["bPos"]:     # liste des connexions borne +
    idc = id[0]            
    if idc == idd: continue
    for i in disp["bNeg"]:  # liste des connexions borne -
     if i[0] == idc:    
      if id == i: continue   
      dc =self.dTemp[idc]
      sbc = id[1]    
      if sbc =="p": sens =1
      else: sens =-1
      if (dc["E"] ==None and disp["E"] ==None) \
      or (dc["E"] !=None and disp["E"] !=None \
       and dc["R"] <RiGm and disp["R"] <RiGm ) :
       if dc["E"] !=None and disp["E"] !=None :
        if dc["E"] != disp["E"]:
         self.genPd =True
         return True        
        else:
         self.genPar +=1    
       Fem =disp["E"]
       if Fem==None: Fem =0
       diR =disp["R"]
       disp["R"] = 1/(1/diR + 1/dc["R"])
       self.assoc.append("%s#=%s,%s,%s,%s,%s" %\
            (idd, idc, diR, dc["R"], sens, Fem)) 
       del self.dTemp[idc]    
       self.SplashWindow(idc)
       return False
  return True
switchPol().mainloop()